// /tmp/build-stella/stella-3.0.0.beta/native/cpp/stella/conses.hh

/*--------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2001      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK ----------------------------*/



namespace stella {

// Global declarations:
extern Cons* NIL;
extern int oREMOVE_DUPLICATES_CROSSOVER_POINTo;
extern DECLARE_STELLA_SPECIAL(oPRINTPRETTYpo, boolean );
extern DECLARE_STELLA_SPECIAL(oPRINTREADABLYpo, boolean );
extern Symbol* ELIPSIS;
extern DECLARE_STELLA_SPECIAL(oPRINTPRETTYCODEpo, boolean );
extern DECLARE_STELLA_SPECIAL(oDEPTHEXCEEDEDpo, boolean );
extern int oDEPTHCUTOFFo;

// Function signatures:
boolean nilP(Object* x);
Cons* cons(Object* value, Cons* rest);
Cons* local_cons(Object* value, Cons* rest);
Cons* remove_duplicates_from_long_list(Cons* self);
Cons* map_null_to_nil(Cons* self);
Cons* last_cons(Cons* self);
boolean terminate_cons_iteratorP(Cons_Iterator* self);
void add_cons_to_end_of_cons_list(Cons* self, Cons* lastcons);
boolean but_last_nextP(All_Purpose_Iterator* self);
Cons* copy_cons_list(Cons* self);
Cons* cons_list(int values, ...);
Cons* listO(int values, ...);
Cons* append(Cons* conslist1, Cons* conslist2);
Cons* help_sort_cons_list(Cons* list, int length, cpp_function_code predicate);
Cons* merge_cons_lists(Cons* list1, Cons* list2, cpp_function_code predicate);
boolean generalized_symbol_less_thanP(Generalized_Symbol* x, Generalized_Symbol* y);
boolean wrapped_integer_less_thanP(Integer_Wrapper* x, Integer_Wrapper* y);
boolean wrapped_float_less_thanP(Float_Wrapper* x, Float_Wrapper* y);
boolean wrapped_string_less_thanP(String_Wrapper* x, String_Wrapper* y);
boolean wrapped_mutable_string_less_thanP(Mutable_String_Wrapper* x, Mutable_String_Wrapper* y);
cpp_function_code choose_sort_predicate(Cons* self);
boolean search_cons_treeP(Object* tree, Object* value);
Object* copy_cons_tree(Object* self);
boolean equal_cons_treesP(Object* tree1, Object* tree2);
Object* substitute_cons_tree(Object* tree, Object* newvalue, Object* oldvalue);
void print_cons(Cons* tree, ostream* stream, char* lparen, char* rparen);
void pprint_cons(Cons* tree, ostream* stream, char* lparen, char* rparen);
void print_stella_code(Object* tree, ostream* stream);
void print_stella_definition(Object* tree, ostream* stream);
int tree_size(Object* self);
int safely_compute_tree_size(Cons* tree, int depthcount, int cutoff);
int safe_tree_size(Cons* tree, char*& _return1);
void help_startup_conses1();
void startup_conses();

// Auxiliary global declarations:
extern Surrogate* SGT_CONSES_STELLA_GENERALIZED_SYMBOL;
extern Surrogate* SGT_CONSES_STELLA_MUTABLE_STRING_WRAPPER;
extern Surrogate* SGT_CONSES_STELLA_CONS;
extern Symbol* SYM_CONSES_STELLA_STARTUP_CONSES;
extern Symbol* SYM_CONSES_STELLA_METHOD_STARTUP_CLASSNAME;


} // end of namespace stella
