// cpp-output.cc

/*--------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2001      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK ----------------------------*/

#include "stella/stella-system.hh"

namespace stella {

DEFINE_STELLA_SPECIAL(oCPP_INDENT_CHARSo, int , 0);

// `true' when outputting a defprint, used to 
//             conditionally dereference streams in print-native-stream 
//             statements.  Also used to take the address of streams
//             when passed to functions inside of a defprint
DEFINE_STELLA_SPECIAL(oOUTPUTTINGDEFPRINTpo, boolean , FALSE);

Object* cpp_output_to_string_expander(Cons* statement) {
  { Symbol* oldvar = local_gensym("OLD-CURRENT-STREAM");
    Symbol* resultvar = local_gensym("RESULT");

    return (listO(5, SYM_CPP_OUTPUT_STELLA_VRLET, cons(cons(resultvar, listO(3, SYM_CPP_OUTPUT_STELLA_STRING, SYM_CPP_OUTPUT_STELLA_NULL, NIL)), NIL), listO(4, SYM_CPP_OUTPUT_STELLA_SPECIAL, cons(listO(3, SYM_CPP_OUTPUT_STELLA_oCURRENT_STREAMo, listO(3, SYM_CPP_OUTPUT_STELLA_NEW, SYM_CPP_OUTPUT_STELLA_OUTPUT_STRING_STREAM, NIL), NIL), NIL), statement, cons(listO(3, SYM_CPP_OUTPUT_STELLA_SETQ, resultvar, cons(listO(3, SYM_CPP_OUTPUT_STELLA_THE_STRING, listO(4, SYM_CPP_OUTPUT_STELLA_CAST, SYM_CPP_OUTPUT_STELLA_oCURRENT_STREAMo, SYM_CPP_OUTPUT_STELLA_OUTPUT_STRING_STREAM, NIL), NIL), NIL)), NIL)), resultvar, NIL));
  }
}

void cpp_output_parse_tree(Cons* constree) {
  { 
    BIND_STELLA_SPECIAL(oCPP_INDENT_CHARSo, int, 0);
    cpp_output_statement(constree);
  }
}

Cons* cpp_flatten_statements(Cons* statements) {
  { Surrogate* test_value_000 = safe_primary_type(statements->value);

    if (test_value_000 == SGT_CPP_OUTPUT_STELLA_CONS) {
      { Cons* flattenedsubtree = NIL;
        Cons* flattenedtree = NIL;

        while (!(statements == NIL)) {
          flattenedsubtree = cpp_flatten_statements(((Cons*)(statements->value)));
          if (consP(flattenedsubtree->value)) {
            flattenedtree = flattenedsubtree->reverse()->concatenate(flattenedtree, 0);
          }
          else {
            flattenedtree = cons(flattenedsubtree, flattenedtree);
          }
          statements = statements->rest;
        }
        return (flattenedtree->reverse());
      }
    }
    else if (subtype_of_symbolP(test_value_000)) {
      { Generalized_Symbol* test_value_001 = ((Generalized_Symbol*)(statements->value));

        if ((test_value_001 == SYM_CPP_OUTPUT_STELLA_CPP_PROGN) ||
            (test_value_001 == SYM_CPP_OUTPUT_STELLA_CPP_STATEMENTS)) {
          if (statements->rest == NIL) {
            return (NIL);
          }
          else {
            return (cpp_flatten_statements(statements->rest));
          }
        }
        else {
          return (statements);
        }
      }
    }
    else {
      { Output_String_Stream* stream_000 = new_output_string_stream();

        *(stream_000->native_stream) << "`" << test_value_000 << "'" << " is not a valid case option";
        throw *new_stella_exception(stream_000->the_string_reader());
      }
    }
  }
}

Cons* cpp_prognify_statement(Object* statement) {
  if (cpp_prognP(statement)) {
    return (((Cons*)(statement)));
  }
  else {
    return (listO(3, SYM_CPP_OUTPUT_STELLA_CPP_PROGN, listO(3, SYM_CPP_OUTPUT_STELLA_CPP_STATEMENTS, statement, NIL), NIL));
  }
}

Cons* cpp_statement_to_list(Object* statement) {
  { Cons* flattenedstatement = cpp_flatten_statements(((Cons*)(statement)));

    if (flattenedstatement == statement) {
      return (cons(flattenedstatement, NIL));
    }
    else {
      return (flattenedstatement);
    }
  }
}

void cpp_output_statement(Object* statement) {
  if (safe_primary_type(statement) == SGT_CPP_OUTPUT_STELLA_CONS) {
    { Object* statement_000 = statement;
      Cons* statement = ((Cons*)(statement_000));

      if (statement == NIL) {
        return;
      }
      if (consP(statement->value) ||
          (!((boolean)(statement->value)))) {
        {
          cpp_output_statement(statement->value);
          cpp_output_statement(statement->rest);
        }
      }
      else {
        { Generalized_Symbol* test_value_000 = ((Generalized_Symbol*)(statement->value));

          if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_COMMENT) {
            cpp_output_comment(((String_Wrapper*)(statement->rest->value)));
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_CLASS) {
            cpp_output_class(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_HANDLER_CASE) {
            cpp_output_handler_case(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_CATCH) {
            cpp_output_catch(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_SIGNAL) {
            cpp_output_signal(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_UNWIND_PROTECT) {
            cpp_output_unwind_protect(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_VERBATIM) {
            cpp_output_verbatim(((String_Wrapper*)(statement->rest->value)));
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_CAST) {
            cpp_output_cast(statement->rest);
          }
          else if ((test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_GLOBAL) ||
              ((test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_SPECIAL) ||
               (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_LOCAL))) {
            cpp_output_variable_definition(statement);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_TYPE) {
            cpp_output_type_expression(((Cons*)(statement->rest)));
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_DEREFERENCE) {
            cpp_output_dereference(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_ARRAY_REFERENCE) {
            cpp_output_array_reference(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_PROGN) {
            cpp_output_progn(((Cons*)(statement->rest->value)));
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_WITH_PROCESS_LOCK) {
            cpp_output_with_process_lock(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_BREAK) {
            cpp_output_break();
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_CONTINUE) {
            cpp_output_continue();
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_IF) {
            cpp_output_if(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_FUNCTION_SIGNATURE) {
            cpp_output_funcall_function_signature(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_METHOD_SIGNATURE) {
            cpp_output_method_code_call_signature(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_COND) {
            cpp_output_cond(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_CASE) {
            cpp_output_case(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_WHEN) {
            cpp_output_when(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_UNLESS) {
            cpp_output_unless(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_ASSIGN) {
            cpp_output_assignment(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_LOOP) {
            cpp_output_loop(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_WHILE) {
            cpp_output_while(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_FOREACH) {
            cpp_output_foreach(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_BLOCK) {
            cpp_output_block(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_IDENT) {
            cpp_output_identifier(((String_Wrapper*)(statement->rest->value)));
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_PRINT_STREAM) {
            cpp_output_print_stream(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_PRINT_NATIVE_STREAM) {
            cpp_output_print_native_stream(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_LITERAL) {
            statement->rest->value->cpp_output_literal();
          }
          else if ((test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_FUNCTION) ||
              (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_METHOD)) {
            cpp_output_function(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_RETURN) {
            cpp_output_return(((Cons*)(statement->rest->value)));
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_SYMBOL) {
            statement->rest->value->cpp_output_literal();
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_MAKE) {
            cpp_output_make(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_FUNCALL) {
            cpp_output_funcall(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_METHOD_CODE_CALL) {
            cpp_output_method_code_call(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_FUNCTION_POINTER) {
            cpp_output_function_pointer(((String_Wrapper*)(statement->rest->value)));
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_METHOD_POINTER) {
            cpp_output_method_pointer(((String_Wrapper*)(statement->rest->value)));
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_SLOT_VALUE) {
            cpp_output_slot_value(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_REFERENCED_SLOT_VALUE) {
            cpp_output_referenced_slot_value(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_SLOT_VALUE_SETTER) {
            cpp_output_slot_value_setter(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_DECLARATIONS) {
            cpp_output_declarations(((Keyword*)(statement->rest->value)), ((Cons*)(statement->rest->rest->value)));
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_DEFINITIONS) {
            cpp_output_definitions(((Keyword*)(statement->rest->value)), ((Cons*)(statement->rest->rest->value)));
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_SIGNATURES) {
            cpp_output_signatures(((Keyword*)(statement->rest->value)), ((Cons*)(statement->rest->rest->value)));
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_STATEMENTS) {
            cpp_output_statements(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_UNARY_OP) {
            cpp_output_unary_operator(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_BINARY_OP) {
            cpp_output_binary_operator(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_TERNARY_OP) {
            cpp_output_ternary_operator(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_FUNCTION_CALL) {
            cpp_output_function_call(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_METHOD_SETTER_CALL) {
            cpp_output_method_setter_call(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_METHOD_CALL) {
            cpp_output_method_call(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_REFERENCED_METHOD_CALL) {
            cpp_output_referenced_method_call(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_ACTUALS) {
            cpp_output_actual_parameters(statement->rest);
          }
          else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_DEFPRINT) {
            cpp_output_defprint(statement->rest);
          }
          else {
            { Output_String_Stream* stream_000 = new_output_string_stream();

              *(stream_000->native_stream) << "`" << test_value_000 << "'" << " is not a valid case option";
              throw *new_stella_exception(stream_000->the_string_reader());
            }
          }
        }
      }
    }
  }
  else {
    if (!((boolean)(statement))) {
      return;
    }
    cpp_output_atomic_expression(statement);
  }
}

void cpp_output_verbatim(String_Wrapper* verbatimstatement) {
  *(oCURRENT_STREAMo.get()->native_stream) << verbatimstatement->wrapper_value;
}

void cpp_output_comment(String_Wrapper* tree) {
  *(oCURRENT_STREAMo.get()->native_stream) << "// ";
  { boolean newlinep = FALSE;
    boolean returnp = FALSE;

    { char renamed_Char = NULL_CHARACTER;
      char* vector_000 = tree->wrapper_value;
      int index_000 = 0;
      int length_000 = strlen(vector_000);

      while (index_000 < length_000) {
        renamed_Char = vector_000[index_000];
        index_000 = index_000 + 1;
        switch (renamed_Char) {
          case '\n': 
            if (!(returnp)) {
              *(oCURRENT_STREAMo.get()->native_stream) << endl;
              cpp_indent();
              *(oCURRENT_STREAMo.get()->native_stream) << "// ";
            }
            returnp = FALSE;
            newlinep = TRUE;
          break;
          case '\r': 
            *(oCURRENT_STREAMo.get()->native_stream) << endl;
            cpp_indent();
            *(oCURRENT_STREAMo.get()->native_stream) << "// ";
            returnp = TRUE;
            newlinep = FALSE;
          break;
          default:
            *(oCURRENT_STREAMo.get()->native_stream) << renamed_Char;
            returnp = FALSE;
            newlinep = FALSE;
          break;
        }
      }
    }
    *(oCURRENT_STREAMo.get()->native_stream) << endl;
  }
}

void cpp_output_dereference(Cons* tree) {
  *(oCURRENT_STREAMo.get()->native_stream) << "*";
  cpp_output_statement(tree);
}

void cpp_output_array_reference(Cons* tree) {
  cpp_maybe_output_statement_with_parentheses(tree->value);
  { Object* indexexpression = NULL;
    Cons* iter_000 = tree->rest;

    while (!(iter_000 == NIL)) {
      indexexpression = iter_000->value;
      iter_000 = iter_000->rest;
      *(oCURRENT_STREAMo.get()->native_stream) << "[";
      cpp_output_statement(indexexpression);
      *(oCURRENT_STREAMo.get()->native_stream) << "]";
    }
  }
}

void cpp_output_cast(Cons* tree) {
  *(oCURRENT_STREAMo.get()->native_stream) << "((" << ((String_Wrapper*)(tree->rest->value))->wrapper_value << ")(";
  cpp_output_statement(tree->value);
  *(oCURRENT_STREAMo.get()->native_stream) << "))";
}

void cpp_output_signal(Cons* tree) {
  *(oCURRENT_STREAMo.get()->native_stream) << "throw ";
  cpp_output_statement(tree->value);
}

void cpp_output_handler_case(Cons* tree) {
  *(oCURRENT_STREAMo.get()->native_stream) << "try {" << endl;
  cpp_bump_indent();
  cpp_output_statements(cpp_statement_to_list(tree->value));
  cpp_unbump_indent();
  cpp_indent();
  *(oCURRENT_STREAMo.get()->native_stream) << "}" << endl;
  cpp_output_statements(tree->rest);
}

void cpp_output_catch(Cons* tree) {
  { Cons* variabledecl = ((Cons*)(tree->value));

    *(oCURRENT_STREAMo.get()->native_stream) << "catch (";
    cpp_output_statement(variabledecl->value);
    if (((boolean)(variabledecl->rest->value))) {
      cpp_output_statement(variabledecl->rest->value);
    }
    *(oCURRENT_STREAMo.get()->native_stream) << ") {" << endl;
    cpp_bump_indent();
    cpp_output_statements(cpp_flatten_statements(tree->rest));
    cpp_unbump_indent();
    cpp_indent();
    *(oCURRENT_STREAMo.get()->native_stream) << "}" << endl;
  }
}

void cpp_output_unwind_protect(Cons* tree) {
  *(oCURRENT_STREAMo.get()->native_stream) << "try {" << endl;
  cpp_bump_indent();
  cpp_output_statements(cpp_statement_to_list(tree->value));
  cpp_unbump_indent();
  cpp_indent();
  *(oCURRENT_STREAMo.get()->native_stream) << "}" << endl;
  *(oCURRENT_STREAMo.get()->native_stream) << "catch (...) {" << endl;
  cpp_bump_indent();
  cpp_output_statements(tree->rest);
  cpp_indent();
  *(oCURRENT_STREAMo.get()->native_stream) << "throw;" << endl;
  cpp_unbump_indent();
  cpp_indent();
  *(oCURRENT_STREAMo.get()->native_stream) << "}" << endl;
  cpp_output_statements(tree->rest);
}

void cpp_output_global_declaration(Cons* global) {
  { Object* kind = global->value;
    Object* type = global->rest->rest->value;
    Object* name = global->fourth();

    *(oCURRENT_STREAMo.get()->native_stream) << "extern ";
    if (((Generalized_Symbol*)(kind)) == SYM_CPP_OUTPUT_STELLA_CPP_SPECIAL) {
      if (special_implementation_style() == KWD_CPP_OUTPUT_UNBIND_WITH_DESTRUCTORS) {
        cpp_output_statement(listO(4, SYM_CPP_OUTPUT_STELLA_CPP_FUNCTION_CALL, listO(3, SYM_CPP_OUTPUT_STELLA_CPP_IDENT, wrap_string("DECLARE_STELLA_SPECIAL"), NIL), listO(4, SYM_CPP_OUTPUT_STELLA_CPP_ACTUALS, listO(3, SYM_CPP_OUTPUT_STELLA_CPP_IDENT, name, NIL), type, NIL), NIL));
      }
      else {
        cpp_output_typed_entity(type, name, NULL);
      }
    }
    else {
      cpp_output_typed_entity(type, name, NULL);
    }
    *(oCURRENT_STREAMo.get()->native_stream) << ";" << endl;
  }
}

void cpp_output_variable_definition(Cons* variable) {
  { Object* kind = variable->value;
    char* documentation = unwrap_string(((String_Wrapper*)(variable->rest->value)));
    Object* type = variable->rest->rest->value;
    Object* name = variable->fourth();
    Object* initialvalue = variable->fifth();

    if (documentation != NULL) {
      cpp_output_comment(wrap_string(documentation));
    }
    if (((Generalized_Symbol*)(kind)) == SYM_CPP_OUTPUT_STELLA_CPP_SPECIAL) {
      if (special_implementation_style() == KWD_CPP_OUTPUT_UNBIND_WITH_DESTRUCTORS) {
        cpp_output_statement(listO(4, SYM_CPP_OUTPUT_STELLA_CPP_FUNCTION_CALL, listO(3, SYM_CPP_OUTPUT_STELLA_CPP_IDENT, wrap_string("DEFINE_STELLA_SPECIAL"), NIL), listO(4, SYM_CPP_OUTPUT_STELLA_CPP_ACTUALS, listO(3, SYM_CPP_OUTPUT_STELLA_CPP_IDENT, name, NIL), type, cons(initialvalue, NIL)), NIL));
      }
      else {
        cpp_output_typed_entity(type, name, initialvalue);
      }
    }
    else {
      cpp_output_typed_entity(type, name, initialvalue);
    }
    *(oCURRENT_STREAMo.get()->native_stream) << ";" << endl << endl;
  }
}

void cpp_output_funcall_function_signature(Cons* signature) {
  { Cons* returntypes = ((Cons*)(signature->value));
    String_Wrapper* returntype = ((String_Wrapper*)(returntypes->value));
    Cons* parametertypes = ((Cons*)(signature->rest->value));
    int nofparameters = parametertypes->length();

    { char* result_000 = NULL;

      { 
        BIND_STELLA_SPECIAL(oCURRENT_STREAMo, Output_Stream*, new_output_string_stream());
        {
          *(oCURRENT_STREAMo.get()->native_stream) << " (*) (";
          { String_Wrapper* partype = NULL;
            int i = NULL_INTEGER;
            Cons* iter_000 = parametertypes;
            int iter_001 = 1;
            int upper_bound_000 = nofparameters;
            boolean unboundedP_000 = upper_bound_000 == NULL_INTEGER;

            while ((!(iter_000 == NIL)) &&
                (unboundedP_000 ||
                 (iter_001 <= upper_bound_000))) {
              partype = ((String_Wrapper*)(iter_000->value));
              iter_000 = iter_000->rest;
              i = iter_001;
              iter_001 = iter_001 + 1;
              *(oCURRENT_STREAMo.get()->native_stream) << partype->wrapper_value;
              if (i < nofparameters) {
                *(oCURRENT_STREAMo.get()->native_stream) << ", ";
              }
            }
          }
          *(oCURRENT_STREAMo.get()->native_stream) << ")";
        }
        result_000 = ((Output_String_Stream*)(oCURRENT_STREAMo.get()))->the_string_reader();
      }
      { char* baresignature = result_000;

        *(oCURRENT_STREAMo.get()->native_stream) << "(";
        cpp_output_typed_entity(returntype, wrap_string(baresignature), NULL);
        *(oCURRENT_STREAMo.get()->native_stream) << ")";
      }
    }
  }
}

void cpp_output_method_code_call_signature(Cons* signature) {
  { Cons* returntypes = ((Cons*)(signature->value));
    String_Wrapper* returntype = ((String_Wrapper*)(returntypes->value));
    char* objecttype = ((String_Wrapper*)(signature->rest->value))->wrapper_value;
    Cons* parametertypes = ((Cons*)(signature->rest->rest->value));
    int nofparameters = parametertypes->length();

    { char* result_000 = NULL;

      { 
        BIND_STELLA_SPECIAL(oCURRENT_STREAMo, Output_Stream*, new_output_string_stream());
        {
          *(oCURRENT_STREAMo.get()->native_stream) << " (";
          *(oCURRENT_STREAMo.get()->native_stream) << objecttype;
          *(oCURRENT_STREAMo.get()->native_stream) << "::*) (";
          { String_Wrapper* partype = NULL;
            int i = NULL_INTEGER;
            Cons* iter_000 = parametertypes;
            int iter_001 = 1;
            int upper_bound_000 = nofparameters;
            boolean unboundedP_000 = upper_bound_000 == NULL_INTEGER;

            while ((!(iter_000 == NIL)) &&
                (unboundedP_000 ||
                 (iter_001 <= upper_bound_000))) {
              partype = ((String_Wrapper*)(iter_000->value));
              iter_000 = iter_000->rest;
              i = iter_001;
              iter_001 = iter_001 + 1;
              *(oCURRENT_STREAMo.get()->native_stream) << partype->wrapper_value;
              if (i < nofparameters) {
                *(oCURRENT_STREAMo.get()->native_stream) << ", ";
              }
            }
          }
          *(oCURRENT_STREAMo.get()->native_stream) << ")";
        }
        result_000 = ((Output_String_Stream*)(oCURRENT_STREAMo.get()))->the_string_reader();
      }
      { char* baresignature = result_000;

        *(oCURRENT_STREAMo.get()->native_stream) << "(";
        cpp_output_typed_entity(returntype, wrap_string(baresignature), NULL);
        *(oCURRENT_STREAMo.get()->native_stream) << ")";
      }
    }
  }
}

void cpp_output_funcall(Cons* funcall) {
  *(oCURRENT_STREAMo.get()->native_stream) << "(";
  cpp_output_statement(funcall->value);
  cpp_output_statement(funcall->rest->value);
  *(oCURRENT_STREAMo.get()->native_stream) << ")";
  cpp_output_statement(funcall->rest->rest->value);
}

void cpp_output_method_code_call(Cons* methodcall) {
  *(oCURRENT_STREAMo.get()->native_stream) << "(";
  cpp_maybe_output_statement_with_parentheses(methodcall->rest->rest->value);
  *(oCURRENT_STREAMo.get()->native_stream) << "->*(";
  cpp_output_statement(methodcall->value);
  *(oCURRENT_STREAMo.get()->native_stream) << " ";
  cpp_output_statement(methodcall->rest->value);
  *(oCURRENT_STREAMo.get()->native_stream) << ")) ";
  cpp_output_statement(methodcall->fourth());
}

void cpp_output_break() {
  *(oCURRENT_STREAMo.get()->native_stream) << "break;" << endl;
}

void cpp_output_continue() {
  *(oCURRENT_STREAMo.get()->native_stream) << "continue;" << endl;
}

boolean last_statement_is_returnP(Cons* statements) {
  { Cons* lastitem = ((Cons*)(statements->last()));

    return (((boolean)(lastitem)) &&
        (lastitem->value == SYM_CPP_OUTPUT_STELLA_CPP_RETURN));
  }
}

void cpp_output_case(Cons* renamed_Case) {
  { Object* keyform = renamed_Case->value;
    Object* defaultcase = renamed_Case->rest->value;
    Object* conditions = renamed_Case->rest->rest->value;

    *(oCURRENT_STREAMo.get()->native_stream) << "switch (";
    cpp_output_statement(keyform);
    *(oCURRENT_STREAMo.get()->native_stream) << ") {" << endl;
    cpp_bump_indent();
    { Cons* c = NULL;
      Cons* iter_000 = ((Cons*)(conditions));

      while (!(iter_000 == NIL)) {
        c = ((Cons*)(iter_000->value));
        iter_000 = iter_000->rest;
        { Cons* condition = c;

          { Object* cond = NULL;
            Cons* iter_001 = ((Cons*)((consP(((Cons*)(condition->value))->value) ? condition->value : cons(condition->value, NIL))));

            while (!(iter_001 == NIL)) {
              cond = iter_001->value;
              iter_001 = iter_001->rest;
              cpp_indent();
              *(oCURRENT_STREAMo.get()->native_stream) << "case ";
              cpp_output_statement(cond);
              *(oCURRENT_STREAMo.get()->native_stream) << ": " << endl;
            }
          }
          cpp_bump_indent();
          cpp_output_statement(condition->rest->value);
          cpp_unbump_indent();
          if (!(last_statement_is_returnP(((Cons*)(condition->rest->value))))) {
            cpp_indent();
            *(oCURRENT_STREAMo.get()->native_stream) << "break;" << endl;
          }
        }
      }
    }
    if (!((boolean)(defaultcase))) {
      cerr << "Safety violation: " << "INTERNAL ERROR: `cpp-output-case' expects an `otherwise' clause.";
    }
    cpp_indent();
    *(oCURRENT_STREAMo.get()->native_stream) << "default:" << endl;
    cpp_bump_indent();
    cpp_output_statement(defaultcase);
    cpp_unbump_indent();
    if (!(last_statement_is_returnP(((Cons*)(defaultcase))))) {
      cpp_indent();
      *(oCURRENT_STREAMo.get()->native_stream) << "break;" << endl;
    }
    cpp_unbump_indent();
    cpp_indent();
    *(oCURRENT_STREAMo.get()->native_stream) << "}" << endl;
  }
}

void cpp_output_cond(Cons* cond) {
  { Cons* defaultcondition = ((Cons*)(cond->value));
    Cons* conditions = ((Cons*)(cond->rest->value));
    Cons* firstcondition = ((Cons*)(conditions->value));
    Cons* restconditions = conditions->rest;

    if (((boolean)(defaultcondition)) &&
        (conditions == NIL)) {
      *(oCURRENT_STREAMo.get()->native_stream) << "if (TRUE) ";
      cpp_output_statement(defaultcondition);
      return;
    }
    *(oCURRENT_STREAMo.get()->native_stream) << "if (";
    cpp_output_statement(firstcondition->value);
    *(oCURRENT_STREAMo.get()->native_stream) << ") ";
    cpp_output_statement(firstcondition->rest->value);
    { Object* c = NULL;
      Cons* iter_000 = restconditions;

      while (!(iter_000 == NIL)) {
        c = iter_000->value;
        iter_000 = iter_000->rest;
        { Cons* condition = ((Cons*)(c));

          cpp_indent();
          *(oCURRENT_STREAMo.get()->native_stream) << "else if (";
          cpp_output_statement(condition->value);
          *(oCURRENT_STREAMo.get()->native_stream) << ") ";
          cpp_output_statement(condition->rest->value);
        }
      }
    }
    if (((boolean)(defaultcondition))) {
      cpp_indent();
      *(oCURRENT_STREAMo.get()->native_stream) << "else ";
      cpp_output_statement(defaultcondition);
    }
  }
}

boolean cpp_prognP(Object* tree) {
  return (consP(tree) &&
      (((Cons*)(tree))->value == SYM_CPP_OUTPUT_STELLA_CPP_PROGN));
}

boolean cpp_blockP(Object* tree) {
  if (safe_primary_type(tree) == SGT_CPP_OUTPUT_STELLA_CONS) {
    { Object* tree_000 = tree;
      Cons* tree = ((Cons*)(tree_000));

      { Generalized_Symbol* test_value_000 = ((Generalized_Symbol*)(tree->value));

        if ((test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_BLOCK) ||
            (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_PROGN)) {
          return (TRUE);
        }
        else {
        }
      }
    }
  }
  else {
  }
  return (FALSE);
}

void cpp_output_if(Cons* tree) {
  *(oCURRENT_STREAMo.get()->native_stream) << "if (";
  cpp_output_statement(tree->value);
  *(oCURRENT_STREAMo.get()->native_stream) << ") ";
  if (cpp_blockP(tree->rest->value)) {
    cpp_output_statement(tree->rest->value);
  }
  else {
    {
      *(oCURRENT_STREAMo.get()->native_stream) << endl;
      cpp_bump_indent();
      cpp_indent();
      cpp_output_statement(tree->rest->value);
      *(oCURRENT_STREAMo.get()->native_stream) << ";" << endl;
      cpp_unbump_indent();
    }
  }
  if (!(!((boolean)(tree->rest->rest->value)))) {
    cpp_indent();
    *(oCURRENT_STREAMo.get()->native_stream) << "else ";
    if (cpp_blockP(tree->rest->rest->value)) {
      cpp_output_statement(tree->rest->rest->value);
    }
    else {
      {
        *(oCURRENT_STREAMo.get()->native_stream) << endl;
        cpp_bump_indent();
        cpp_indent();
        cpp_output_statement(tree->rest->rest->value);
        *(oCURRENT_STREAMo.get()->native_stream) << ";" << endl;
        cpp_unbump_indent();
      }
    }
  }
}

void cpp_output_when(Cons* tree) {
  *(oCURRENT_STREAMo.get()->native_stream) << "if (";
  cpp_output_statement(tree->value);
  *(oCURRENT_STREAMo.get()->native_stream) << ") {" << endl;
  cpp_bump_indent();
  cpp_output_statement(tree->rest->value);
  cpp_unbump_indent();
  cpp_indent();
  *(oCURRENT_STREAMo.get()->native_stream) << "}" << endl;
}

void cpp_output_unless(Cons* tree) {
  *(oCURRENT_STREAMo.get()->native_stream) << "if (!(";
  cpp_output_statement(tree->value);
  *(oCURRENT_STREAMo.get()->native_stream) << ")) {" << endl;
  cpp_bump_indent();
  cpp_output_statement(tree->rest->value);
  cpp_unbump_indent();
  cpp_indent();
  *(oCURRENT_STREAMo.get()->native_stream) << "}" << endl;
}

void cpp_output_assignment(Cons* assignment) {
  cpp_output_statement(assignment->value);
  *(oCURRENT_STREAMo.get()->native_stream) << " = ";
  cpp_output_statement(assignment->rest->value);
}

void cpp_output_loop(Cons* loop) {
  *(oCURRENT_STREAMo.get()->native_stream) << "for (;;) ";
  cpp_output_statement(loop->value);
}

void cpp_output_while(Cons* loop) {
  *(oCURRENT_STREAMo.get()->native_stream) << "while (";
  cpp_output_statement(loop->value);
  *(oCURRENT_STREAMo.get()->native_stream) << ") ";
  cpp_output_statement(loop->rest->value);
}

void cpp_output_foreach(Cons* loop) {
  { Object* continuationtest = loop->value;
    Cons* nextassignments = ((Cons*)(loop->rest->value));
    Cons* body = ((Cons*)(loop->rest->rest->value));

    *(oCURRENT_STREAMo.get()->native_stream) << "while (";
    cpp_output_statement(continuationtest);
    *(oCURRENT_STREAMo.get()->native_stream) << ") {" << endl;
    cpp_bump_indent();
    loop->second_setter(NULL);
    loop->third_setter(cpp_flatten_statements(nextassignments->concatenate(body, 0)));
    cpp_output_statements(((Cons*)(loop->rest->rest->value)));
    cpp_unbump_indent();
    cpp_indent();
    *(oCURRENT_STREAMo.get()->native_stream) << "}" << endl;
  }
}

void cpp_output_function_pointer(String_Wrapper* functionname) {
  *(oCURRENT_STREAMo.get()->native_stream) << "&" << functionname->wrapper_value;
}

void cpp_output_method_pointer(String_Wrapper* methodname) {
  *(oCURRENT_STREAMo.get()->native_stream) << "&" << methodname->wrapper_value;
}

void cpp_output_slot_value(Cons* statement) {
  cpp_maybe_output_statement_with_parentheses(statement->value);
  *(oCURRENT_STREAMo.get()->native_stream) << "->" << ((String_Wrapper*)(statement->rest->value))->wrapper_value;
}

void cpp_output_referenced_slot_value(Cons* statement) {
  cpp_maybe_output_statement_with_parentheses(statement->value);
  *(oCURRENT_STREAMo.get()->native_stream) << "." << ((String_Wrapper*)(statement->rest->value))->wrapper_value;
}

void cpp_output_slot_value_setter(Cons* statement) {
  cpp_maybe_output_statement_with_parentheses(statement->value);
  *(oCURRENT_STREAMo.get()->native_stream) << "->" << ((String_Wrapper*)(statement->rest->value))->wrapper_value << " = ";
  cpp_output_statement(statement->rest->rest->value);
}

void cpp_output_make(Cons* statement) {
  *(oCURRENT_STREAMo.get()->native_stream) << "new ";
  cpp_output_statement(statement->value);
  if (((boolean)(statement->rest->value))) {
    cpp_output_statement(statement->rest->value);
  }
}

void cpp_bump_indent() {
  oCPP_INDENT_CHARSo.set(oCPP_INDENT_CHARSo.get() + 2);
}

void cpp_unbump_indent() {
  oCPP_INDENT_CHARSo.set(oCPP_INDENT_CHARSo.get() - 2);
}

void Object::cpp_output_literal() {
  { Object* object = this;

  }
}

void Character_Wrapper::cpp_output_literal() {
  { Character_Wrapper* character = this;

    switch (character->wrapper_value) {
      case '\'': 
        *(oCURRENT_STREAMo.get()->native_stream) << "'\\''";
      break;
      case '\\': 
        *(oCURRENT_STREAMo.get()->native_stream) << "'\\\\'";
      break;
      case '\n': 
        *(oCURRENT_STREAMo.get()->native_stream) << "'\\n'";
      break;
      case '\b': 
        *(oCURRENT_STREAMo.get()->native_stream) << "'\\b'";
      break;
      case '\t': 
        *(oCURRENT_STREAMo.get()->native_stream) << "'\\t'";
      break;
      case '\r': 
        *(oCURRENT_STREAMo.get()->native_stream) << "'\\r'";
      break;
      case '\f': 
        *(oCURRENT_STREAMo.get()->native_stream) << "'\\f'";
      break;
      default:
        *(oCURRENT_STREAMo.get()->native_stream) << "'" << character->wrapper_value << "'";
      break;
    }
  }
}

void Integer_Wrapper::cpp_output_literal() {
  { Integer_Wrapper* renamed_Int = this;

    *(oCURRENT_STREAMo.get()->native_stream) << renamed_Int->wrapper_value;
  }
}

void Float_Wrapper::cpp_output_literal() {
  { Float_Wrapper* renamed_Float = this;

    *(oCURRENT_STREAMo.get()->native_stream) << renamed_Float->wrapper_value;
  }
}

void Boolean_Wrapper::cpp_output_literal() {
  { Boolean_Wrapper* boolean = this;

    if (boolean->wrapper_value) {
      *(oCURRENT_STREAMo.get()->native_stream) << "TRUE";
    }
    else {
      *(oCURRENT_STREAMo.get()->native_stream) << "FALSE";
    }
  }
}

void Cons::cpp_output_literal() {
  { Cons* cons = this;

    if (cons == NIL) {
      *(oCURRENT_STREAMo.get()->native_stream) << "NIL";
    }
    else {
      {
        *(oCURRENT_STREAMo.get()->native_stream) << "(" << cons->value << " . ";
        cons->rest->cpp_output_literal();
      }
    }
  }
}

char* replace_character_with_substring(char* string, char* renamed_New, char character) {
  return (replace_substrings(string, renamed_New, make_string(1, character)));
}

void string_cpp_output_literal(char* string) {
  *(oCURRENT_STREAMo.get()->native_stream) << "\"" << replace_substrings(replace_substrings(replace_substrings(replace_substrings(string, "\\\\", "\\"), "\\\"", make_string(1, '"')), "\\n", make_string(1, '\n')), "\\r", make_string(1, '\r')) << "\"";
}

void String_Wrapper::cpp_output_literal() {
  { String_Wrapper* string = this;

    string_cpp_output_literal(string->wrapper_value);
  }
}

void Mutable_String_Wrapper::cpp_output_literal() {
  { Mutable_String_Wrapper* string = this;

    string_cpp_output_literal((string->wrapper_value));
  }
}

void Quoted_Expression::cpp_output_literal() {
  { Quoted_Expression* tree = this;

    *(oCURRENT_STREAMo.get()->native_stream) << "\"" << tree << "\"";
  }
}

void Symbol::cpp_output_literal() {
  { Symbol* symbol = this;

    *(oCURRENT_STREAMo.get()->native_stream) << cpp_translate_symbol_name(symbol)->wrapper_value;
  }
}

void Surrogate::cpp_output_literal() {
  { Surrogate* surrogate = this;

    *(oCURRENT_STREAMo.get()->native_stream) << cpp_translate_surrogate_name(surrogate)->wrapper_value;
  }
}

void Keyword::cpp_output_literal() {
  { Keyword* keyword = this;

    *(oCURRENT_STREAMo.get()->native_stream) << cpp_translate_keyword_name(keyword)->wrapper_value;
  }
}

void cpp_output_identifier(String_Wrapper* identifier) {
  *(oCURRENT_STREAMo.get()->native_stream) << identifier->wrapper_value;
}

void cpp_output_atomic_expression(Object* atom) {
  { Generalized_Symbol* test_value_000 = ((Generalized_Symbol*)(atom));

    if (test_value_000 == SYM_CPP_OUTPUT_STELLA_NEWLINE) {
      *(oCURRENT_STREAMo.get()->native_stream) << endl;
    }
    else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_NULL_VALUE) {
      *(oCURRENT_STREAMo.get()->native_stream) << "NULL_VALUE";
    }
    else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_ASSIGN) {
      *(oCURRENT_STREAMo.get()->native_stream) << "=";
    }
    else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_SCOLON) {
      *(oCURRENT_STREAMo.get()->native_stream) << ";";
    }
    else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_LPAREN) {
      *(oCURRENT_STREAMo.get()->native_stream) << "(";
    }
    else if (test_value_000 == SYM_CPP_OUTPUT_STELLA_RPAREN) {
      *(oCURRENT_STREAMo.get()->native_stream) << ")";
    }
    else {
      atom->cpp_output_literal();
    }
  }
}

void cpp_indent() {
  { int d = NULL_INTEGER;
    int iter_000 = 1;
    int upper_bound_000 = oCPP_INDENT_CHARSo.get();
    boolean unboundedP_000 = upper_bound_000 == NULL_INTEGER;

    while (unboundedP_000 ||
        (iter_000 <= upper_bound_000)) {
      d = iter_000;
      iter_000 = iter_000 + 1;
      *(oCURRENT_STREAMo.get()->native_stream) << " ";
    }
  }
}

boolean cpp_output_semicolonP(Cons* statement) {
  if (((boolean)(statement))) {
    { Generalized_Symbol* test_value_000 = ((Generalized_Symbol*)(statement->value));

      if ((test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_ASSIGN) ||
          ((test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_UNARY_OP) ||
           ((test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_BINARY_OP) ||
            ((test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_TERNARY_OP) ||
             ((test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_CAST) ||
              ((test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_FUNCALL) ||
               ((test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_FUNCTION_CALL) ||
                ((test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_FUNCTION_POINTER) ||
                 ((test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_MAKE) ||
                  ((test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_METHOD_CALL) ||
                   ((test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_METHOD_CODE_CALL) ||
                    ((test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_METHOD_POINTER) ||
                     ((test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_METHOD_SETTER_CALL) ||
                      ((test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_NEW) ||
                       ((test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_PRINT_NATIVE_STREAM) ||
                        ((test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_PRINT_STREAM) ||
                         ((test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_REFERENCED_METHOD_CALL) ||
                          ((test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_RETURN) ||
                           ((test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_SIGNAL) ||
                            ((test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_SLOT_VALUE_SETTER) ||
                             ((test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_THROW) ||
                              (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_VERBATIM)))))))))))))))))))))) {
        return (TRUE);
      }
      else {
      }
    }
  }
  return (FALSE);
}

boolean cpp_indent_statementP(Cons* statement) {
  if (((boolean)(statement))) {
    return (!get_quoted_tree("((CPP_STATEMENTS) \"/STELLA\")", "/STELLA")->memberP(statement->value));
  }
  else {
    return (FALSE);
  }
}

boolean illegal_cpp_statementP(Cons* statement) {
  if (((boolean)(statement))) {
    { Generalized_Symbol* test_value_000 = ((Generalized_Symbol*)(statement->value));

      if ((test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_LITERAL) ||
          (test_value_000 == SYM_CPP_OUTPUT_STELLA_CPP_IDENT)) {
        return (TRUE);
      }
      else {
      }
    }
  }
  return (FALSE);
}

void cpp_output_statements(Cons* statementlist) {
  { Object* statement = NULL;
    Cons* iter_000 = statementlist;

    while (!(iter_000 == NIL)) {
      statement = iter_000->value;
      iter_000 = iter_000->rest;
      if (!(illegal_cpp_statementP(((Cons*)(statement))))) {
        if (cpp_indent_statementP(((Cons*)(statement)))) {
          cpp_indent();
        }
        cpp_output_statement(statement);
        if (cpp_output_semicolonP(((Cons*)(statement)))) {
          *(oCURRENT_STREAMo.get()->native_stream) << ";" << endl;
        }
      }
    }
  }
}

void cpp_maybe_output_statement_with_parentheses(Object* statement) {
  { boolean operatorP = cpp_operatorP(statement);

    if (operatorP) {
      *(oCURRENT_STREAMo.get()->native_stream) << "(";
    }
    cpp_output_statement(statement);
    if (operatorP) {
      *(oCURRENT_STREAMo.get()->native_stream) << ")";
    }
  }
}

void cpp_output_stream_print_items(Cons* items) {
  { Object* e = NULL;
    Cons* iter_000 = items;

    while (!(iter_000 == NIL)) {
      e = iter_000->value;
      iter_000 = iter_000->rest;
      *(oCURRENT_STREAMo.get()->native_stream) << " << ";
      cpp_maybe_output_statement_with_parentheses(e);
    }
  }
}

void cpp_output_print_stream(Cons* exps) {
  { Object* stream = exps->value;

    if (stream == SYM_CPP_OUTPUT_STELLA_CPP_STANDARD_OUT) {
      *(oCURRENT_STREAMo.get()->native_stream) << "cout";
    }
    else if (stream == SYM_CPP_OUTPUT_STELLA_CPP_STANDARD_ERROR) {
      *(oCURRENT_STREAMo.get()->native_stream) << "cerr";
    }
    else {
      *(oCURRENT_STREAMo.get()->native_stream) << "get_ostream(";
      cpp_output_statement(stream);
      *(oCURRENT_STREAMo.get()->native_stream) << ")";
    }
    cpp_output_stream_print_items(exps->rest);
  }
}

void cpp_output_print_native_stream(Cons* exps) {
  { Object* stream = exps->value;

    if (stream == SYM_CPP_OUTPUT_STELLA_CPP_STANDARD_OUT) {
      *(oCURRENT_STREAMo.get()->native_stream) << "cout";
    }
    else if (stream == SYM_CPP_OUTPUT_STELLA_CPP_STANDARD_ERROR) {
      *(oCURRENT_STREAMo.get()->native_stream) << "cerr";
    }
    else {
      if (!(oOUTPUTTINGDEFPRINTpo.get())) {
        *(oCURRENT_STREAMo.get()->native_stream) << "*(";
      }
      cpp_output_statement(stream);
      if (!(oOUTPUTTINGDEFPRINTpo.get())) {
        *(oCURRENT_STREAMo.get()->native_stream) << ")";
      }
    }
    cpp_output_stream_print_items(exps->rest);
  }
}

boolean cpp_indentable_binary_operatorP(String_Wrapper* renamed_Operator) {
  return (get_quoted_tree("((\"||\" \"&&\") \"/STELLA\")", "/STELLA")->memberP(renamed_Operator));
}

boolean cpp_commutative_binary_operatorP(String_Wrapper* renamed_Operator) {
  return (get_quoted_tree("((\"+\" \"*\") \"/STELLA\")", "/STELLA")->memberP(renamed_Operator));
}

boolean cpp_binary_operatorP(Object* statement) {
  return (consP(statement) &&
      (SYM_CPP_OUTPUT_STELLA_CPP_BINARY_OP == ((Cons*)(statement))->value));
}

boolean cpp_operatorP(Object* statement) {
  return (consP(statement) &&
      get_quoted_tree("((CPP_UNARY_OP CPP_BINARY_OP CPP_TERNARY_OP CPP_ASSIGN CPP_SLOT_VALUE_SETTER) \"/STELLA\")", "/STELLA")->memberP(((Cons*)(statement))->value));
}

boolean cpp_assignmentP(Cons* statement) {
  return (statement->value == SYM_CPP_OUTPUT_STELLA_CPP_ASSIGN);
}

void cpp_output_unary_operator(Cons* expression) {
  { String_Wrapper* op = NULL;
    Object* arg = NULL;
    boolean postfixP = FALSE;

    if (subtype_of_stringP(safe_primary_type(expression->value))) {
      op = ((String_Wrapper*)(expression->value));
      arg = expression->rest->value;
    }
    else {
      op = ((String_Wrapper*)(expression->rest->value));
      arg = expression->value;
      postfixP = TRUE;
    }
    if (!(postfixP)) {
      *(oCURRENT_STREAMo.get()->native_stream) << op->wrapper_value;
    }
    cpp_maybe_output_statement_with_parentheses(arg);
    if (postfixP) {
      *(oCURRENT_STREAMo.get()->native_stream) << op->wrapper_value;
    }
  }
}

boolean cpp_nested_operator_needs_parenthesesP(String_Wrapper* op, Object* nested) {
  return (cpp_operatorP(nested) &&
      (!(cpp_commutative_binary_operatorP(op) &&
      string_eqlP(op->wrapper_value, ((String_Wrapper*)(((Cons*)(nested))->rest->rest->value))->wrapper_value))));
}

void cpp_help_output_binary_operator(Cons* expression, int nestlevel) {
  { Object* arg1 = expression->value;
    String_Wrapper* op = ((String_Wrapper*)(expression->rest->value));
    Object* arg2 = expression->rest->rest->value;

    if (cpp_nested_operator_needs_parenthesesP(op, arg1)) {
      *(oCURRENT_STREAMo.get()->native_stream) << "(";
    }
    if (cpp_binary_operatorP(op)) {
      cpp_help_output_binary_operator(((Cons*)(arg1))->rest, nestlevel + 1);
    }
    else {
      cpp_output_statement(arg1);
    }
    if (cpp_nested_operator_needs_parenthesesP(op, arg1)) {
      *(oCURRENT_STREAMo.get()->native_stream) << ")";
    }
    *(oCURRENT_STREAMo.get()->native_stream) << " ";
    *(oCURRENT_STREAMo.get()->native_stream) << op->wrapper_value;
    if (cpp_indentable_binary_operatorP(op)) {
      {
        *(oCURRENT_STREAMo.get()->native_stream) << endl;
        cpp_indent();
        *(oCURRENT_STREAMo.get()->native_stream) << "    ";
        { int d = NULL_INTEGER;
          int iter_000 = 1;
          int upper_bound_000 = nestlevel;
          boolean unboundedP_000 = upper_bound_000 == NULL_INTEGER;

          while (unboundedP_000 ||
              (iter_000 <= upper_bound_000)) {
            d = iter_000;
            iter_000 = iter_000 + 1;
            *(oCURRENT_STREAMo.get()->native_stream) << " ";
          }
        }
      }
    }
    else {
      *(oCURRENT_STREAMo.get()->native_stream) << " ";
    }
    if (cpp_nested_operator_needs_parenthesesP(op, arg2)) {
      *(oCURRENT_STREAMo.get()->native_stream) << "(";
    }
    if (cpp_binary_operatorP(arg2)) {
      cpp_help_output_binary_operator(((Cons*)(arg2))->rest, nestlevel + 1);
    }
    else {
      cpp_output_statement(arg2);
    }
    if (cpp_nested_operator_needs_parenthesesP(op, arg2)) {
      *(oCURRENT_STREAMo.get()->native_stream) << ")";
    }
  }
}

void cpp_output_binary_operator(Cons* expression) {
  cpp_help_output_binary_operator(expression, 0);
}

void cpp_output_ternary_operator(Cons* expression) {
  { Object* arg1 = expression->value;
    String_Wrapper* op1 = ((String_Wrapper*)(expression->rest->value));
    Object* arg2 = expression->rest->rest->value;
    String_Wrapper* op2 = ((String_Wrapper*)(expression->fourth()));
    Object* arg3 = expression->fifth();
    char* translatedarg = NULL;

    *(oCURRENT_STREAMo.get()->native_stream) << "(";
    cpp_maybe_output_statement_with_parentheses(arg1);
    *(oCURRENT_STREAMo.get()->native_stream) << " ";
    *(oCURRENT_STREAMo.get()->native_stream) << op1->wrapper_value;
    *(oCURRENT_STREAMo.get()->native_stream) << " ";
    { char* result_000 = NULL;

      { 
        BIND_STELLA_SPECIAL(oCURRENT_STREAMo, Output_Stream*, new_output_string_stream());
        cpp_maybe_output_statement_with_parentheses(arg2);
        result_000 = ((Output_String_Stream*)(oCURRENT_STREAMo.get()))->the_string_reader();
      }
      translatedarg = result_000;
    }
    if (translatedarg[0] == '"') {
      *(oCURRENT_STREAMo.get()->native_stream) << "(char*)";
    }
    *(oCURRENT_STREAMo.get()->native_stream) << translatedarg;
    *(oCURRENT_STREAMo.get()->native_stream) << " ";
    *(oCURRENT_STREAMo.get()->native_stream) << op2->wrapper_value;
    *(oCURRENT_STREAMo.get()->native_stream) << " ";
    { char* result_001 = NULL;

      { 
        BIND_STELLA_SPECIAL(oCURRENT_STREAMo, Output_Stream*, new_output_string_stream());
        cpp_maybe_output_statement_with_parentheses(arg3);
        result_001 = ((Output_String_Stream*)(oCURRENT_STREAMo.get()))->the_string_reader();
      }
      translatedarg = result_001;
    }
    if (translatedarg[0] == '"') {
      *(oCURRENT_STREAMo.get()->native_stream) << "(char*)";
    }
    *(oCURRENT_STREAMo.get()->native_stream) << translatedarg;
    *(oCURRENT_STREAMo.get()->native_stream) << ")";
  }
}

void cpp_output_statement_line(Cons* statement) {
  cpp_output_statement(statement->value);
  { Object* e = NULL;
    Cons* iter_000 = statement->rest;

    while (!(iter_000 == NIL)) {
      e = iter_000->value;
      iter_000 = iter_000->rest;
      *(oCURRENT_STREAMo.get()->native_stream) << " ";
      cpp_output_statement(e);
    }
  }
  *(oCURRENT_STREAMo.get()->native_stream) << ";" << endl;
}

void cpp_output_return(Cons* returnstatement) {
  *(oCURRENT_STREAMo.get()->native_stream) << "return";
  if (((boolean)(returnstatement))) {
    *(oCURRENT_STREAMo.get()->native_stream) << " (";
    cpp_output_statement(returnstatement);
    *(oCURRENT_STREAMo.get()->native_stream) << ")";
  }
}

void cpp_output_type_expression(Cons* typeexpression) {
  { String_Wrapper* typeexpr = NULL;
    Cons* iter_000 = typeexpression;

    while (!(iter_000 == NIL)) {
      typeexpr = ((String_Wrapper*)(iter_000->value));
      iter_000 = iter_000->rest;
      *(oCURRENT_STREAMo.get()->native_stream) << typeexpr->wrapper_value << " ";
    }
  }
}

void cpp_output_typed_entity(Object* type, Object* entity, Object* initialvalue) {
  { boolean arraytypeP = cpp_translated_array_typeP(type);

    if (arraytypeP) {
      { char* translatedtype = NULL;
        char* translatedentity = NULL;

        { Surrogate* test_value_000 = safe_primary_type(type);

          if (test_value_000 == SGT_CPP_OUTPUT_STELLA_CONS) {
            { Object* type_000 = type;
              Cons* type = ((Cons*)(type_000));

              if (!(type->value == SYM_CPP_OUTPUT_STELLA_CPP_TYPE)) {
                type = cons(SYM_CPP_OUTPUT_STELLA_CPP_TYPE, type);
              }
              { char* result_000 = NULL;

                { 
                  BIND_STELLA_SPECIAL(oCURRENT_STREAMo, Output_Stream*, new_output_string_stream());
                  cpp_output_statement(type);
                  result_000 = ((Output_String_Stream*)(oCURRENT_STREAMo.get()))->the_string_reader();
                }
                translatedtype = result_000;
              }
            }
          }
          else if (subtype_of_stringP(test_value_000)) {
            { Object* type_001 = type;
              String_Wrapper* type = ((String_Wrapper*)(type_001));

              translatedtype = type->wrapper_value;
            }
          }
          else {
            { Output_String_Stream* stream_000 = new_output_string_stream();

              *(stream_000->native_stream) << "`" << test_value_000 << "'" << " is not a valid case option";
              throw *new_stella_exception(stream_000->the_string_reader());
            }
          }
        }
        { Surrogate* test_value_001 = safe_primary_type(entity);

          if (test_value_001 == SGT_CPP_OUTPUT_STELLA_CONS) {
            { Object* entity_000 = entity;
              Cons* entity = ((Cons*)(entity_000));

              { char* result_001 = NULL;

                { 
                  BIND_STELLA_SPECIAL(oCURRENT_STREAMo, Output_Stream*, new_output_string_stream());
                  cpp_output_statement(entity);
                  result_001 = ((Output_String_Stream*)(oCURRENT_STREAMo.get()))->the_string_reader();
                }
                translatedentity = result_001;
              }
            }
          }
          else if (subtype_of_stringP(test_value_001)) {
            { Object* entity_001 = entity;
              String_Wrapper* entity = ((String_Wrapper*)(entity_001));

              translatedentity = entity->wrapper_value;
            }
          }
          else {
            { Output_String_Stream* stream_001 = new_output_string_stream();

              *(stream_001->native_stream) << "`" << test_value_001 << "'" << " is not a valid case option";
              throw *new_stella_exception(stream_001->the_string_reader());
            }
          }
        }
        *(oCURRENT_STREAMo.get()->native_stream) << cpp_generate_array_typed_entity(translatedentity, translatedtype);
      }
    }
    else {
      { Surrogate* test_value_002 = safe_primary_type(type);

        if (test_value_002 == SGT_CPP_OUTPUT_STELLA_CONS) {
          { Object* type_002 = type;
            Cons* type = ((Cons*)(type_002));

            if (!(type->value == SYM_CPP_OUTPUT_STELLA_CPP_TYPE)) {
              type = cons(SYM_CPP_OUTPUT_STELLA_CPP_TYPE, type);
            }
            cpp_output_statement(type);
          }
        }
        else if (subtype_of_stringP(test_value_002)) {
          { Object* type_003 = type;
            String_Wrapper* type = ((String_Wrapper*)(type_003));

            *(oCURRENT_STREAMo.get()->native_stream) << type->wrapper_value << " ";
          }
        }
        else {
          { Output_String_Stream* stream_002 = new_output_string_stream();

            *(stream_002->native_stream) << "`" << test_value_002 << "'" << " is not a valid case option";
            throw *new_stella_exception(stream_002->the_string_reader());
          }
        }
      }
      { Surrogate* test_value_003 = safe_primary_type(entity);

        if (test_value_003 == SGT_CPP_OUTPUT_STELLA_CONS) {
          { Object* entity_002 = entity;
            Cons* entity = ((Cons*)(entity_002));

            cpp_output_statement(entity);
          }
        }
        else if (subtype_of_stringP(test_value_003)) {
          { Object* entity_003 = entity;
            String_Wrapper* entity = ((String_Wrapper*)(entity_003));

            *(oCURRENT_STREAMo.get()->native_stream) << entity->wrapper_value;
          }
        }
        else {
          { Output_String_Stream* stream_003 = new_output_string_stream();

            *(stream_003->native_stream) << "`" << test_value_003 << "'" << " is not a valid case option";
            throw *new_stella_exception(stream_003->the_string_reader());
          }
        }
      }
    }
    if (((boolean)(initialvalue))) {
      *(oCURRENT_STREAMo.get()->native_stream) << " = ";
      cpp_output_statement(initialvalue);
    }
  }
}

void cpp_output_declarations(Keyword* accesscontrolmode, Cons* declarations) {
  cpp_indent();
  if (accesscontrolmode == KWD_CPP_OUTPUT_PUBLIC) {
    *(oCURRENT_STREAMo.get()->native_stream) << "public:" << endl;
  }
  else if (accesscontrolmode == KWD_CPP_OUTPUT_PRIVATE) {
    *(oCURRENT_STREAMo.get()->native_stream) << "private:" << endl;
  }
  else if (accesscontrolmode == KWD_CPP_OUTPUT_PROTECTED) {
    *(oCURRENT_STREAMo.get()->native_stream) << "protected:" << endl;
  }
  else {
    { Output_String_Stream* stream_000 = new_output_string_stream();

      *(stream_000->native_stream) << "`" << accesscontrolmode << "'" << " is not a valid case option";
      throw *new_stella_exception(stream_000->the_string_reader());
    }
  }
  if (((boolean)(accesscontrolmode))) {
    cpp_bump_indent();
  }
  { Cons* declaration = NULL;
    Cons* iter_000 = declarations;

    while (!(iter_000 == NIL)) {
      declaration = ((Cons*)(iter_000->value));
      iter_000 = iter_000->rest;
      cpp_indent();
      cpp_output_typed_entity(declaration->value, declaration->rest->value, NULL);
      *(oCURRENT_STREAMo.get()->native_stream) << ";" << endl;
    }
  }
  if (((boolean)(accesscontrolmode))) {
    cpp_unbump_indent();
  }
}

void cpp_output_signature(Cons* signature, boolean outputmethodclassP) {
  { String_Wrapper* methodclass = ((String_Wrapper*)(signature->value));
    Object* returntype = signature->rest->value;
    String_Wrapper* name = ((String_Wrapper*)(signature->rest->rest->value));
    Object* parameters = signature->fourth();

    { char* result_000 = NULL;

      { 
        BIND_STELLA_SPECIAL(oCURRENT_STREAMo, Output_Stream*, new_output_string_stream());
        {
          if (outputmethodclassP &&
              ((boolean)(methodclass))) {
            *(oCURRENT_STREAMo.get()->native_stream) << methodclass->wrapper_value;
            *(oCURRENT_STREAMo.get()->native_stream) << "::";
          }
          *(oCURRENT_STREAMo.get()->native_stream) << name->wrapper_value;
          cpp_output_formal_parameters(((Cons*)(parameters)));
        }
        result_000 = ((Output_String_Stream*)(oCURRENT_STREAMo.get()))->the_string_reader();
      }
      { char* baresignature = result_000;

        cpp_output_typed_entity(returntype, wrap_string(baresignature), NULL);
      }
    }
  }
}

void cpp_output_signatures(Keyword* accesscontrolmode, Cons* signatures) {
  cpp_indent();
  if (accesscontrolmode == KWD_CPP_OUTPUT_PUBLIC) {
    *(oCURRENT_STREAMo.get()->native_stream) << "public:" << endl;
  }
  else if (accesscontrolmode == KWD_CPP_OUTPUT_PRIVATE) {
    *(oCURRENT_STREAMo.get()->native_stream) << "private:" << endl;
  }
  else if (accesscontrolmode == KWD_CPP_OUTPUT_PROTECTED) {
    *(oCURRENT_STREAMo.get()->native_stream) << "protected:" << endl;
  }
  else {
    { Output_String_Stream* stream_000 = new_output_string_stream();

      *(stream_000->native_stream) << "`" << accesscontrolmode << "'" << " is not a valid case option";
      throw *new_stella_exception(stream_000->the_string_reader());
    }
  }
  if (((boolean)(accesscontrolmode))) {
    cpp_bump_indent();
  }
  { Object* signature = NULL;
    Cons* iter_000 = signatures;

    while (!(iter_000 == NIL)) {
      signature = iter_000->value;
      iter_000 = iter_000->rest;
      cpp_indent();
      cpp_output_signature(((Cons*)(signature)), FALSE);
      *(oCURRENT_STREAMo.get()->native_stream) << ";" << endl;
    }
  }
  if (((boolean)(accesscontrolmode))) {
    cpp_unbump_indent();
  }
}

void cpp_output_definitions(Keyword* accesscontrolmode, Cons* definitions) {
  cpp_indent();
  if (accesscontrolmode == KWD_CPP_OUTPUT_PUBLIC) {
    *(oCURRENT_STREAMo.get()->native_stream) << "public:" << endl;
  }
  else if (accesscontrolmode == KWD_CPP_OUTPUT_PRIVATE) {
    *(oCURRENT_STREAMo.get()->native_stream) << "private:" << endl;
  }
  else if (accesscontrolmode == KWD_CPP_OUTPUT_PROTECTED) {
    *(oCURRENT_STREAMo.get()->native_stream) << "protected:" << endl;
  }
  else {
    { Output_String_Stream* stream_000 = new_output_string_stream();

      *(stream_000->native_stream) << "`" << accesscontrolmode << "'" << " is not a valid case option";
      throw *new_stella_exception(stream_000->the_string_reader());
    }
  }
  if (((boolean)(accesscontrolmode))) {
    cpp_bump_indent();
  }
  { Object* definition = NULL;
    Cons* iter_000 = definitions;

    while (!(iter_000 == NIL)) {
      definition = iter_000->value;
      iter_000 = iter_000->rest;
      cpp_indent();
      cpp_output_statement(definition);
    }
  }
  if (((boolean)(accesscontrolmode))) {
    cpp_unbump_indent();
  }
}

void cpp_output_progn(Cons* progn) {
  *(oCURRENT_STREAMo.get()->native_stream) << "{" << endl;
  cpp_bump_indent();
  cpp_output_statement(progn);
  cpp_unbump_indent();
  cpp_indent();
  *(oCURRENT_STREAMo.get()->native_stream) << "}" << endl;
}

void cpp_output_block(Cons* block) {
  { boolean firststatementP = TRUE;

    *(oCURRENT_STREAMo.get()->native_stream) << "{ ";
    cpp_bump_indent();
    { Cons* declaration = NULL;
      Cons* iter_000 = ((Cons*)(block->value));

      while (!(iter_000 == NIL)) {
        declaration = ((Cons*)(iter_000->value));
        iter_000 = iter_000->rest;
        if (!(firststatementP)) {
          cpp_indent();
        }
        firststatementP = FALSE;
        cpp_output_typed_entity(declaration->value, declaration->rest->value, declaration->rest->rest->value);
        *(oCURRENT_STREAMo.get()->native_stream) << ";" << endl;
      }
    }
    *(oCURRENT_STREAMo.get()->native_stream) << endl;
    cpp_output_statement(block->rest->value);
    cpp_unbump_indent();
    cpp_indent();
    *(oCURRENT_STREAMo.get()->native_stream) << "}" << endl;
  }
}

void cpp_output_with_process_lock(Cons* synch) {
  { Output_String_Stream* s = new_output_string_stream();

    { 
      BIND_STELLA_SPECIAL(oCURRENT_STREAMo, Output_Stream*, s);
      cpp_output_statement(synch->value);
    }
    cpp_output_comment(wrap_string(string_concatenate("Should be synchronized on process lock ", s->the_string_reader(), 0)));
    cpp_indent();
  }
  cpp_output_progn(((Cons*)(synch->rest->value)));
}

void cpp_output_static_member_vars(String_Wrapper* renamed_Class, Cons* declarations) {
  { Cons* declaration = NULL;
    Cons* iter_000 = declarations;

    while (!(iter_000 == NIL)) {
      declaration = ((Cons*)(iter_000->value));
      iter_000 = iter_000->rest;
      cpp_indent();
      cpp_output_typed_entity(declaration->value, wrap_string(string_concatenate(renamed_Class->wrapper_value, "::", 1, ((String_Wrapper*)(declaration->rest->value))->wrapper_value)), declaration->rest->rest->value);
      *(oCURRENT_STREAMo.get()->native_stream) << ";" << endl;
    }
  }
  if (!(declarations == NIL)) {
    *(oCURRENT_STREAMo.get()->native_stream) << endl;
  }
}

void cpp_output_derived_classes(Cons* classlist) {
  if (((boolean)(classlist->value))) {
    *(oCURRENT_STREAMo.get()->native_stream) << ((String_Wrapper*)(classlist->value))->wrapper_value;
  }
  { Object* renamed_Class = NULL;
    Cons* iter_000 = classlist->rest;

    while (!(iter_000 == NIL)) {
      renamed_Class = iter_000->value;
      iter_000 = iter_000->rest;
      *(oCURRENT_STREAMo.get()->native_stream) << ", public ";
      if (oTRANSLATOROUTPUTLANGUAGEo.get() == KWD_CPP_OUTPUT_CPP_STANDALONE) {
        *(oCURRENT_STREAMo.get()->native_stream) << "virtual ";
      }
      else {
      }
      *(oCURRENT_STREAMo.get()->native_stream) << ((String_Wrapper*)(renamed_Class))->wrapper_value;
    }
  }
  *(oCURRENT_STREAMo.get()->native_stream) << " ";
}

void cpp_output_template_parameters(Cons* parameters) {
  if (!(parameters == NIL)) {
    *(oCURRENT_STREAMo.get()->native_stream) << "template <";
    *(oCURRENT_STREAMo.get()->native_stream) << "class " << ((String_Wrapper*)(parameters->value))->wrapper_value;
    { Object* parameter = NULL;
      Cons* iter_000 = parameters->rest;

      while (!(iter_000 == NIL)) {
        parameter = iter_000->value;
        iter_000 = iter_000->rest;
        *(oCURRENT_STREAMo.get()->native_stream) << "class " << ((String_Wrapper*)(parameter)) << ", ";
      }
    }
    *(oCURRENT_STREAMo.get()->native_stream) << ">" << endl;
  }
}

boolean cpp_output_template_classesP() {
  return (oTRANSLATOROUTPUTLANGUAGEo.get() == KWD_CPP_OUTPUT_CPP_STANDALONE);
}

void cpp_output_class(Cons* classdef) {
  if (cpp_output_template_classesP()) {
    cpp_output_template_parameters(((Cons*)(classdef->rest->value)));
  }
  *(oCURRENT_STREAMo.get()->native_stream) << "class " << ((String_Wrapper*)(classdef->value))->wrapper_value << " ";
  if (!(((Cons*)(classdef->rest->rest->value)) == NIL)) {
    *(oCURRENT_STREAMo.get()->native_stream) << ": public ";
    if (oTRANSLATOROUTPUTLANGUAGEo.get() == KWD_CPP_OUTPUT_CPP_STANDALONE) {
      *(oCURRENT_STREAMo.get()->native_stream) << "virtual ";
    }
    else {
    }
    cpp_output_derived_classes(((Cons*)(classdef->rest->rest->value)));
  }
  *(oCURRENT_STREAMo.get()->native_stream) << "{" << endl;
  { Object* statement = NULL;
    Cons* iter_000 = classdef->nth_rest(4);

    while (!(iter_000 == NIL)) {
      statement = iter_000->value;
      iter_000 = iter_000->rest;
      cpp_output_statement(statement);
    }
  }
  *(oCURRENT_STREAMo.get()->native_stream) << "};" << endl << endl;
  cpp_output_static_member_vars(((String_Wrapper*)(classdef->value)), ((Cons*)(classdef->fourth())));
}

void cpp_output_formal_parameters(Cons* parameters) {
  { int n_parameters = parameters->length();
    boolean variable_argumentsP = FALSE;

    *(oCURRENT_STREAMo.get()->native_stream) << "(";
    { Cons* parameter = NULL;
      int n = NULL_INTEGER;
      Cons* iter_000 = parameters;
      int iter_001 = 1;
      int upper_bound_000 = n_parameters;
      boolean unboundedP_000 = upper_bound_000 == NULL_INTEGER;

      while ((!(iter_000 == NIL)) &&
          (unboundedP_000 ||
           (iter_001 <= upper_bound_000))) {
        parameter = ((Cons*)(iter_000->value));
        iter_000 = iter_000->rest;
        n = iter_001;
        iter_001 = iter_001 + 1;
        if (n == n_parameters) {
          {
            variable_argumentsP = parameter->value == SYM_CPP_OUTPUT_STELLA_CPP_VAR_ARGS;
            cpp_output_typed_entity((variable_argumentsP ? wrap_string("int") : parameter->value), parameter->rest->value, NULL);
            if (variable_argumentsP) {
              *(oCURRENT_STREAMo.get()->native_stream) << ", ...";
            }
          }
        }
        else {
          {
            cpp_output_typed_entity(parameter->value, parameter->rest->value, NULL);
            *(oCURRENT_STREAMo.get()->native_stream) << ", ";
          }
        }
      }
    }
    *(oCURRENT_STREAMo.get()->native_stream) << ")";
  }
}

boolean cpp_argument_is_streamP(Object* arg) {
  if (safe_primary_type(arg) == SGT_CPP_OUTPUT_STELLA_CONS) {
    { Object* arg_000 = arg;
      Cons* arg = ((Cons*)(arg_000));

      return ((arg->value == SYM_CPP_OUTPUT_STELLA_CPP_IDENT) &&
          eql_to_stringP(arg->rest->value, "stream"));
    }
  }
  else {
    return (FALSE);
  }
}

void cpp_output_one_actual_parameter(Object* parameter) {
  if (oOUTPUTTINGDEFPRINTpo.get() &&
      cpp_argument_is_streamP(parameter)) {
    {
      *(oCURRENT_STREAMo.get()->native_stream) << "&";
      cpp_output_statement(parameter);
    }
  }
  else {
    cpp_output_statement(parameter);
  }
}

void cpp_output_actual_parameters(Cons* parameters) {
  *(oCURRENT_STREAMo.get()->native_stream) << "(";
  if (((boolean)(parameters->value))) {
    cpp_output_one_actual_parameter(parameters->value);
  }
  { Object* parameter = NULL;
    Cons* iter_000 = parameters->rest;

    while (!(iter_000 == NIL)) {
      parameter = iter_000->value;
      iter_000 = iter_000->rest;
      *(oCURRENT_STREAMo.get()->native_stream) << ", ";
      cpp_output_one_actual_parameter(parameter);
    }
  }
  *(oCURRENT_STREAMo.get()->native_stream) << ")";
}

void cpp_output_method_setter_call(Cons* methodsettercall) {
  cpp_maybe_output_statement_with_parentheses(methodsettercall->rest->value);
  *(oCURRENT_STREAMo.get()->native_stream) << "->";
  cpp_output_statement(methodsettercall->value);
  *(oCURRENT_STREAMo.get()->native_stream) << "_setter(";
  cpp_output_statement(methodsettercall->rest->rest->value);
  *(oCURRENT_STREAMo.get()->native_stream) << ")";
}

void cpp_output_method_call(Cons* methodcall) {
  cpp_maybe_output_statement_with_parentheses(methodcall->rest->rest->value);
  *(oCURRENT_STREAMo.get()->native_stream) << "->";
  cpp_output_statement(methodcall->rest->value);
  cpp_output_statement(methodcall->fourth());
}

void cpp_output_referenced_method_call(Cons* methodcall) {
  cpp_maybe_output_statement_with_parentheses(methodcall->rest->rest->value);
  *(oCURRENT_STREAMo.get()->native_stream) << ".";
  cpp_output_statement(methodcall->rest->value);
  cpp_output_statement(methodcall->fourth());
}

void cpp_output_function_call(Cons* functioncall) {
  cpp_output_statement(functioncall->value);
  cpp_output_statement(functioncall->rest->value);
}

void cpp_output_defprint_signature(Cons* defprint) {
  *(oCURRENT_STREAMo.get()->native_stream) << "ostream& operator<< (ostream& stream, ";
  *(oCURRENT_STREAMo.get()->native_stream) << ((String_Wrapper*)(defprint->value))->wrapper_value;
  *(oCURRENT_STREAMo.get()->native_stream) << " self)";
}

void cpp_output_defprint(Cons* defprint) {
  cpp_output_defprint_signature(defprint);
  *(oCURRENT_STREAMo.get()->native_stream) << " {" << endl;
  cpp_bump_indent();
  { 
    BIND_STELLA_SPECIAL(oOUTPUTTINGDEFPRINTpo, boolean, TRUE);
    cpp_output_statement(defprint->rest->value);
  }
  cpp_unbump_indent();
  *(oCURRENT_STREAMo.get()->native_stream) << "}" << endl;
  *(oCURRENT_STREAMo.get()->native_stream) << endl;
}

void cpp_output_function_signature(Cons* function) {
  { char* result_000 = NULL;

    { 
      BIND_STELLA_SPECIAL(oCURRENT_STREAMo, Output_Stream*, new_output_string_stream());
      {
        *(oCURRENT_STREAMo.get()->native_stream) << ((String_Wrapper*)(function->rest->value))->wrapper_value;
        cpp_output_formal_parameters(((Cons*)(function->rest->rest->value)));
      }
      result_000 = ((Output_String_Stream*)(oCURRENT_STREAMo.get()))->the_string_reader();
    }
    { char* baresignature = result_000;

      cpp_output_typed_entity(function->value, wrap_string(baresignature), NULL);
    }
  }
}

void cpp_output_function(Cons* function) {
  { Object* body = function->fourth();
    Cons* basemembers = ((Cons*)(function->fifth()));

    cpp_output_function_signature(function);
    if (((boolean)(basemembers))) {
      *(oCURRENT_STREAMo.get()->native_stream) << " : ";
      { Object* member = NULL;
        Cons* iter_000 = basemembers;

        while (!(iter_000 == NIL)) {
          member = iter_000->value;
          iter_000 = iter_000->rest;
          cpp_output_statement(member);
        }
      }
    }
    *(oCURRENT_STREAMo.get()->native_stream) << " {" << endl;
    cpp_bump_indent();
    cpp_output_statement(body);
    cpp_unbump_indent();
    *(oCURRENT_STREAMo.get()->native_stream) << "}" << endl;
    *(oCURRENT_STREAMo.get()->native_stream) << endl;
  }
}

void help_startup_cpp_output1() {
  {
    SYM_CPP_OUTPUT_STELLA_VRLET = ((Symbol*)(intern_rigid_symbol_wrt_module("VRLET", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_STRING = ((Symbol*)(intern_rigid_symbol_wrt_module("STRING", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_NULL = ((Symbol*)(intern_rigid_symbol_wrt_module("NULL", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_SPECIAL = ((Symbol*)(intern_rigid_symbol_wrt_module("SPECIAL", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_oCURRENT_STREAMo = ((Symbol*)(intern_rigid_symbol_wrt_module("*CURRENT-STREAM*", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_NEW = ((Symbol*)(intern_rigid_symbol_wrt_module("NEW", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_OUTPUT_STRING_STREAM = ((Symbol*)(intern_rigid_symbol_wrt_module("OUTPUT-STRING-STREAM", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_SETQ = ((Symbol*)(intern_rigid_symbol_wrt_module("SETQ", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_THE_STRING = ((Symbol*)(intern_rigid_symbol_wrt_module("THE-STRING", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CAST = ((Symbol*)(intern_rigid_symbol_wrt_module("CAST", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_OUTPUT_TO_STRING = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP-OUTPUT-TO-STRING", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_OUTPUT_TO_STRING_EXPANDER = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP-OUTPUT-TO-STRING-EXPANDER", NULL, 0)));
    SGT_CPP_OUTPUT_STELLA_CONS = ((Surrogate*)(intern_rigid_symbol_wrt_module("CONS", NULL, 1)));
    SYM_CPP_OUTPUT_STELLA_CPP_PROGN = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_PROGN", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_STATEMENTS = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_STATEMENTS", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_COMMENT = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_COMMENT", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_CLASS = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_CLASS", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_HANDLER_CASE = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_HANDLER_CASE", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_CATCH = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_CATCH", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_SIGNAL = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_SIGNAL", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_UNWIND_PROTECT = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_UNWIND_PROTECT", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_VERBATIM = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_VERBATIM", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_CAST = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_CAST", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_GLOBAL = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_GLOBAL", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_SPECIAL = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_SPECIAL", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_LOCAL = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_LOCAL", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_TYPE = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_TYPE", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_DEREFERENCE = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_DEREFERENCE", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_ARRAY_REFERENCE = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_ARRAY_REFERENCE", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_WITH_PROCESS_LOCK = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_WITH_PROCESS_LOCK", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_BREAK = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_BREAK", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_CONTINUE = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_CONTINUE", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_IF = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_IF", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_FUNCTION_SIGNATURE = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_FUNCTION_SIGNATURE", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_METHOD_SIGNATURE = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_METHOD_SIGNATURE", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_COND = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_COND", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_CASE = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_CASE", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_WHEN = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_WHEN", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_UNLESS = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_UNLESS", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_ASSIGN = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_ASSIGN", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_LOOP = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_LOOP", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_WHILE = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_WHILE", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_FOREACH = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_FOREACH", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_BLOCK = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_BLOCK", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_IDENT = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_IDENT", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_PRINT_STREAM = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_PRINT_STREAM", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_PRINT_NATIVE_STREAM = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_PRINT_NATIVE_STREAM", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_LITERAL = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_LITERAL", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_FUNCTION = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_FUNCTION", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_METHOD = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_METHOD", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_RETURN = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_RETURN", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_SYMBOL = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_SYMBOL", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_MAKE = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_MAKE", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_FUNCALL = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_FUNCALL", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_METHOD_CODE_CALL = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_METHOD_CODE_CALL", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_FUNCTION_POINTER = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_FUNCTION_POINTER", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_METHOD_POINTER = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_METHOD_POINTER", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_SLOT_VALUE = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_SLOT_VALUE", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_REFERENCED_SLOT_VALUE = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_REFERENCED_SLOT_VALUE", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_SLOT_VALUE_SETTER = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_SLOT_VALUE_SETTER", NULL, 0)));
  }
}

void help_startup_cpp_output2() {
  {
    SYM_CPP_OUTPUT_STELLA_CPP_DECLARATIONS = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_DECLARATIONS", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_DEFINITIONS = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_DEFINITIONS", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_SIGNATURES = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_SIGNATURES", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_UNARY_OP = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_UNARY_OP", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_BINARY_OP = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_BINARY_OP", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_TERNARY_OP = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_TERNARY_OP", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_FUNCTION_CALL = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_FUNCTION_CALL", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_METHOD_SETTER_CALL = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_METHOD_SETTER_CALL", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_METHOD_CALL = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_METHOD_CALL", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_REFERENCED_METHOD_CALL = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_REFERENCED_METHOD_CALL", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_ACTUALS = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_ACTUALS", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_DEFPRINT = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_DEFPRINT", NULL, 0)));
    KWD_CPP_OUTPUT_UNBIND_WITH_DESTRUCTORS = ((Keyword*)(intern_rigid_symbol_wrt_module("UNBIND-WITH-DESTRUCTORS", NULL, 2)));
    SYM_CPP_OUTPUT_STELLA_NEWLINE = ((Symbol*)(intern_rigid_symbol_wrt_module("NEWLINE", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_NULL_VALUE = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_NULL_VALUE", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_ASSIGN = ((Symbol*)(intern_rigid_symbol_wrt_module("ASSIGN", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_SCOLON = ((Symbol*)(intern_rigid_symbol_wrt_module("SCOLON", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_LPAREN = ((Symbol*)(intern_rigid_symbol_wrt_module("LPAREN", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_RPAREN = ((Symbol*)(intern_rigid_symbol_wrt_module("RPAREN", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_NEW = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_NEW", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_THROW = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_THROW", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_STANDARD_OUT = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_STANDARD_OUT", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_CPP_STANDARD_ERROR = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_STANDARD_ERROR", NULL, 0)));
    KWD_CPP_OUTPUT_PUBLIC = ((Keyword*)(intern_rigid_symbol_wrt_module("PUBLIC", NULL, 2)));
    KWD_CPP_OUTPUT_PRIVATE = ((Keyword*)(intern_rigid_symbol_wrt_module("PRIVATE", NULL, 2)));
    KWD_CPP_OUTPUT_PROTECTED = ((Keyword*)(intern_rigid_symbol_wrt_module("PROTECTED", NULL, 2)));
    KWD_CPP_OUTPUT_CPP_STANDALONE = ((Keyword*)(intern_rigid_symbol_wrt_module("CPP-STANDALONE", NULL, 2)));
    SYM_CPP_OUTPUT_STELLA_CPP_VAR_ARGS = ((Symbol*)(intern_rigid_symbol_wrt_module("CPP_VAR_ARGS", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_STARTUP_CPP_OUTPUT = ((Symbol*)(intern_rigid_symbol_wrt_module("STARTUP-CPP-OUTPUT", NULL, 0)));
    SYM_CPP_OUTPUT_STELLA_METHOD_STARTUP_CLASSNAME = ((Symbol*)(intern_rigid_symbol_wrt_module("METHOD-STARTUP-CLASSNAME", NULL, 0)));
  }
}

void help_startup_cpp_output3() {
  {
    define_function_object("CPP-OUTPUT-TO-STRING-EXPANDER", "(DEFUN (CPP-OUTPUT-TO-STRING-EXPANDER OBJECT) ((STATEMENT CONS)))", ((cpp_function_code)(&cpp_output_to_string_expander)), NULL);
    define_function_object("CPP-OUTPUT-PARSE-TREE", "(DEFUN CPP-OUTPUT-PARSE-TREE ((CONSTREE CONS)))", ((cpp_function_code)(&cpp_output_parse_tree)), NULL);
    define_function_object("CPP-FLATTEN-STATEMENTS", "(DEFUN (CPP-FLATTEN-STATEMENTS CONS) ((STATEMENTS CONS)))", ((cpp_function_code)(&cpp_flatten_statements)), NULL);
    define_function_object("CPP-PROGNIFY-STATEMENT", "(DEFUN (CPP-PROGNIFY-STATEMENT CONS) ((STATEMENT OBJECT)))", ((cpp_function_code)(&cpp_prognify_statement)), NULL);
    define_function_object("CPP-STATEMENT-TO-LIST", "(DEFUN (CPP-STATEMENT-TO-LIST CONS) ((STATEMENT OBJECT)))", ((cpp_function_code)(&cpp_statement_to_list)), NULL);
    define_function_object("CPP-OUTPUT-STATEMENT", "(DEFUN CPP-OUTPUT-STATEMENT ((STATEMENT OBJECT)))", ((cpp_function_code)(&cpp_output_statement)), NULL);
    define_function_object("CPP-OUTPUT-VERBATIM", "(DEFUN CPP-OUTPUT-VERBATIM ((VERBATIMSTATEMENT STRING-WRAPPER)))", ((cpp_function_code)(&cpp_output_verbatim)), NULL);
    define_function_object("CPP-OUTPUT-COMMENT", "(DEFUN CPP-OUTPUT-COMMENT ((TREE STRING-WRAPPER)))", ((cpp_function_code)(&cpp_output_comment)), NULL);
    define_function_object("CPP-OUTPUT-DEREFERENCE", "(DEFUN CPP-OUTPUT-DEREFERENCE ((TREE CONS)))", ((cpp_function_code)(&cpp_output_dereference)), NULL);
    define_function_object("CPP-OUTPUT-ARRAY-REFERENCE", "(DEFUN CPP-OUTPUT-ARRAY-REFERENCE ((TREE CONS)))", ((cpp_function_code)(&cpp_output_array_reference)), NULL);
    define_function_object("CPP-OUTPUT-CAST", "(DEFUN CPP-OUTPUT-CAST ((TREE CONS)))", ((cpp_function_code)(&cpp_output_cast)), NULL);
    define_function_object("CPP-OUTPUT-SIGNAL", "(DEFUN CPP-OUTPUT-SIGNAL ((TREE CONS)))", ((cpp_function_code)(&cpp_output_signal)), NULL);
    define_function_object("CPP-OUTPUT-HANDLER-CASE", "(DEFUN CPP-OUTPUT-HANDLER-CASE ((TREE CONS)))", ((cpp_function_code)(&cpp_output_handler_case)), NULL);
    define_function_object("CPP-OUTPUT-CATCH", "(DEFUN CPP-OUTPUT-CATCH ((TREE CONS)))", ((cpp_function_code)(&cpp_output_catch)), NULL);
    define_function_object("CPP-OUTPUT-UNWIND-PROTECT", "(DEFUN CPP-OUTPUT-UNWIND-PROTECT ((TREE CONS)))", ((cpp_function_code)(&cpp_output_unwind_protect)), NULL);
    define_function_object("CPP-OUTPUT-GLOBAL-DECLARATION", "(DEFUN CPP-OUTPUT-GLOBAL-DECLARATION ((GLOBAL CONS)))", ((cpp_function_code)(&cpp_output_global_declaration)), NULL);
    define_function_object("CPP-OUTPUT-VARIABLE-DEFINITION", "(DEFUN CPP-OUTPUT-VARIABLE-DEFINITION ((VARIABLE CONS)))", ((cpp_function_code)(&cpp_output_variable_definition)), NULL);
    define_function_object("CPP-OUTPUT-FUNCALL-FUNCTION-SIGNATURE", "(DEFUN CPP-OUTPUT-FUNCALL-FUNCTION-SIGNATURE ((SIGNATURE CONS)))", ((cpp_function_code)(&cpp_output_funcall_function_signature)), NULL);
    define_function_object("CPP-OUTPUT-METHOD-CODE-CALL-SIGNATURE", "(DEFUN CPP-OUTPUT-METHOD-CODE-CALL-SIGNATURE ((SIGNATURE CONS)))", ((cpp_function_code)(&cpp_output_method_code_call_signature)), NULL);
    define_function_object("CPP-OUTPUT-FUNCALL", "(DEFUN CPP-OUTPUT-FUNCALL ((FUNCALL CONS)))", ((cpp_function_code)(&cpp_output_funcall)), NULL);
    define_function_object("CPP-OUTPUT-METHOD-CODE-CALL", "(DEFUN CPP-OUTPUT-METHOD-CODE-CALL ((METHODCALL CONS)))", ((cpp_function_code)(&cpp_output_method_code_call)), NULL);
    define_function_object("CPP-OUTPUT-BREAK", "(DEFUN CPP-OUTPUT-BREAK ())", ((cpp_function_code)(&cpp_output_break)), NULL);
    define_function_object("CPP-OUTPUT-CONTINUE", "(DEFUN CPP-OUTPUT-CONTINUE ())", ((cpp_function_code)(&cpp_output_continue)), NULL);
    define_function_object("LAST-STATEMENT-IS-RETURN?", "(DEFUN (LAST-STATEMENT-IS-RETURN? BOOLEAN) ((STATEMENTS CONS)))", ((cpp_function_code)(&last_statement_is_returnP)), NULL);
    define_function_object("CPP-OUTPUT-CASE", "(DEFUN CPP-OUTPUT-CASE ((CASE CONS)))", ((cpp_function_code)(&cpp_output_case)), NULL);
    define_function_object("CPP-OUTPUT-COND", "(DEFUN CPP-OUTPUT-COND ((COND CONS)))", ((cpp_function_code)(&cpp_output_cond)), NULL);
    define_function_object("CPP-PROGN?", "(DEFUN (CPP-PROGN? BOOLEAN) ((TREE OBJECT)))", ((cpp_function_code)(&cpp_prognP)), NULL);
    define_function_object("CPP-BLOCK?", "(DEFUN (CPP-BLOCK? BOOLEAN) ((TREE OBJECT)))", ((cpp_function_code)(&cpp_blockP)), NULL);
    define_function_object("CPP-OUTPUT-IF", "(DEFUN CPP-OUTPUT-IF ((TREE CONS)))", ((cpp_function_code)(&cpp_output_if)), NULL);
    define_function_object("CPP-OUTPUT-WHEN", "(DEFUN CPP-OUTPUT-WHEN ((TREE CONS)))", ((cpp_function_code)(&cpp_output_when)), NULL);
    define_function_object("CPP-OUTPUT-UNLESS", "(DEFUN CPP-OUTPUT-UNLESS ((TREE CONS)))", ((cpp_function_code)(&cpp_output_unless)), NULL);
    define_function_object("CPP-OUTPUT-ASSIGNMENT", "(DEFUN CPP-OUTPUT-ASSIGNMENT ((ASSIGNMENT CONS)))", ((cpp_function_code)(&cpp_output_assignment)), NULL);
    define_function_object("CPP-OUTPUT-LOOP", "(DEFUN CPP-OUTPUT-LOOP ((LOOP CONS)))", ((cpp_function_code)(&cpp_output_loop)), NULL);
    define_function_object("CPP-OUTPUT-WHILE", "(DEFUN CPP-OUTPUT-WHILE ((LOOP CONS)))", ((cpp_function_code)(&cpp_output_while)), NULL);
    define_function_object("CPP-OUTPUT-FOREACH", "(DEFUN CPP-OUTPUT-FOREACH ((LOOP CONS)))", ((cpp_function_code)(&cpp_output_foreach)), NULL);
    define_function_object("CPP-OUTPUT-FUNCTION-POINTER", "(DEFUN CPP-OUTPUT-FUNCTION-POINTER ((FUNCTIONNAME STRING-WRAPPER)))", ((cpp_function_code)(&cpp_output_function_pointer)), NULL);
    define_function_object("CPP-OUTPUT-METHOD-POINTER", "(DEFUN CPP-OUTPUT-METHOD-POINTER ((METHODNAME STRING-WRAPPER)))", ((cpp_function_code)(&cpp_output_method_pointer)), NULL);
    define_function_object("CPP-OUTPUT-SLOT-VALUE", "(DEFUN CPP-OUTPUT-SLOT-VALUE ((STATEMENT CONS)))", ((cpp_function_code)(&cpp_output_slot_value)), NULL);
    define_function_object("CPP-OUTPUT-REFERENCED-SLOT-VALUE", "(DEFUN CPP-OUTPUT-REFERENCED-SLOT-VALUE ((STATEMENT CONS)))", ((cpp_function_code)(&cpp_output_referenced_slot_value)), NULL);
    define_function_object("CPP-OUTPUT-SLOT-VALUE-SETTER", "(DEFUN CPP-OUTPUT-SLOT-VALUE-SETTER ((STATEMENT CONS)))", ((cpp_function_code)(&cpp_output_slot_value_setter)), NULL);
    define_function_object("CPP-OUTPUT-MAKE", "(DEFUN CPP-OUTPUT-MAKE ((STATEMENT CONS)))", ((cpp_function_code)(&cpp_output_make)), NULL);
    define_function_object("CPP-BUMP-INDENT", "(DEFUN CPP-BUMP-INDENT ())", ((cpp_function_code)(&cpp_bump_indent)), NULL);
    define_function_object("CPP-UNBUMP-INDENT", "(DEFUN CPP-UNBUMP-INDENT ())", ((cpp_function_code)(&cpp_unbump_indent)), NULL);
    define_method_object("(DEFMETHOD CPP-OUTPUT-LITERAL ((OBJECT OBJECT)))", ((cpp_method_code)(&Object::cpp_output_literal)), ((cpp_method_code)(NULL)));
    define_method_object("(DEFMETHOD CPP-OUTPUT-LITERAL ((CHARACTER CHARACTER-WRAPPER)))", ((cpp_method_code)(&Character_Wrapper::cpp_output_literal)), ((cpp_method_code)(NULL)));
    define_method_object("(DEFMETHOD CPP-OUTPUT-LITERAL ((INT INTEGER-WRAPPER)))", ((cpp_method_code)(&Integer_Wrapper::cpp_output_literal)), ((cpp_method_code)(NULL)));
    define_method_object("(DEFMETHOD CPP-OUTPUT-LITERAL ((FLOAT FLOAT-WRAPPER)))", ((cpp_method_code)(&Float_Wrapper::cpp_output_literal)), ((cpp_method_code)(NULL)));
    define_method_object("(DEFMETHOD CPP-OUTPUT-LITERAL ((BOOLEAN BOOLEAN-WRAPPER)))", ((cpp_method_code)(&Boolean_Wrapper::cpp_output_literal)), ((cpp_method_code)(NULL)));
    define_method_object("(DEFMETHOD CPP-OUTPUT-LITERAL ((CONS CONS)))", ((cpp_method_code)(&Cons::cpp_output_literal)), ((cpp_method_code)(NULL)));
    define_function_object("REPLACE-CHARACTER-WITH-SUBSTRING", "(DEFUN (REPLACE-CHARACTER-WITH-SUBSTRING STRING) ((STRING STRING) (NEW STRING) (CHARACTER CHARACTER)) :GLOBALLY-INLINE? TRUE (RETURN (REPLACE-SUBSTRINGS STRING NEW CHARACTER)))", ((cpp_function_code)(&replace_character_with_substring)), NULL);
    define_method_object("(DEFMETHOD CPP-OUTPUT-LITERAL ((STRING STRING)))", ((cpp_method_code)(NULL)), ((cpp_method_code)(NULL)));
    define_method_object("(DEFMETHOD CPP-OUTPUT-LITERAL ((STRING STRING-WRAPPER)))", ((cpp_method_code)(&String_Wrapper::cpp_output_literal)), ((cpp_method_code)(NULL)));
    define_method_object("(DEFMETHOD CPP-OUTPUT-LITERAL ((STRING MUTABLE-STRING-WRAPPER)))", ((cpp_method_code)(&Mutable_String_Wrapper::cpp_output_literal)), ((cpp_method_code)(NULL)));
    define_method_object("(DEFMETHOD CPP-OUTPUT-LITERAL ((TREE QUOTED-EXPRESSION)))", ((cpp_method_code)(&Quoted_Expression::cpp_output_literal)), ((cpp_method_code)(NULL)));
    define_method_object("(DEFMETHOD CPP-OUTPUT-LITERAL ((SYMBOL SYMBOL)))", ((cpp_method_code)(&Symbol::cpp_output_literal)), ((cpp_method_code)(NULL)));
    define_method_object("(DEFMETHOD CPP-OUTPUT-LITERAL ((SURROGATE SURROGATE)))", ((cpp_method_code)(&Surrogate::cpp_output_literal)), ((cpp_method_code)(NULL)));
    define_method_object("(DEFMETHOD CPP-OUTPUT-LITERAL ((KEYWORD KEYWORD)))", ((cpp_method_code)(&Keyword::cpp_output_literal)), ((cpp_method_code)(NULL)));
    define_function_object("CPP-OUTPUT-IDENTIFIER", "(DEFUN CPP-OUTPUT-IDENTIFIER ((IDENTIFIER STRING-WRAPPER)))", ((cpp_function_code)(&cpp_output_identifier)), NULL);
    define_function_object("CPP-OUTPUT-ATOMIC-EXPRESSION", "(DEFUN CPP-OUTPUT-ATOMIC-EXPRESSION ((ATOM OBJECT)))", ((cpp_function_code)(&cpp_output_atomic_expression)), NULL);
    define_function_object("CPP-INDENT", "(DEFUN CPP-INDENT ())", ((cpp_function_code)(&cpp_indent)), NULL);
  }
}

void startup_cpp_output() {
  { 
    BIND_STELLA_SPECIAL(oMODULEo, Module*, oSTELLA_MODULEo);
    BIND_STELLA_SPECIAL(oCONTEXTo, Context*, oMODULEo.get());
    if (current_startup_time_phaseP(2)) {
      help_startup_cpp_output1();
      help_startup_cpp_output2();
    }
    if (current_startup_time_phaseP(6)) {
      finalize_classes();
    }
    if (current_startup_time_phaseP(7)) {
      help_startup_cpp_output3();
      define_function_object("CPP-OUTPUT-SEMICOLON?", "(DEFUN (CPP-OUTPUT-SEMICOLON? BOOLEAN) ((STATEMENT CONS)))", ((cpp_function_code)(&cpp_output_semicolonP)), NULL);
      define_function_object("CPP-INDENT-STATEMENT?", "(DEFUN (CPP-INDENT-STATEMENT? BOOLEAN) ((STATEMENT CONS)))", ((cpp_function_code)(&cpp_indent_statementP)), NULL);
      define_function_object("ILLEGAL-CPP-STATEMENT?", "(DEFUN (ILLEGAL-CPP-STATEMENT? BOOLEAN) ((STATEMENT CONS)))", ((cpp_function_code)(&illegal_cpp_statementP)), NULL);
      define_function_object("CPP-OUTPUT-STATEMENTS", "(DEFUN CPP-OUTPUT-STATEMENTS ((STATEMENTLIST CONS)))", ((cpp_function_code)(&cpp_output_statements)), NULL);
      define_function_object("CPP-MAYBE-OUTPUT-STATEMENT-WITH-PARENTHESES", "(DEFUN CPP-MAYBE-OUTPUT-STATEMENT-WITH-PARENTHESES ((STATEMENT OBJECT)))", ((cpp_function_code)(&cpp_maybe_output_statement_with_parentheses)), NULL);
      define_function_object("CPP-OUTPUT-STREAM-PRINT-ITEMS", "(DEFUN CPP-OUTPUT-STREAM-PRINT-ITEMS ((ITEMS CONS)))", ((cpp_function_code)(&cpp_output_stream_print_items)), NULL);
      define_function_object("CPP-OUTPUT-PRINT-STREAM", "(DEFUN CPP-OUTPUT-PRINT-STREAM ((EXPS CONS)))", ((cpp_function_code)(&cpp_output_print_stream)), NULL);
      define_function_object("CPP-OUTPUT-PRINT-NATIVE-STREAM", "(DEFUN CPP-OUTPUT-PRINT-NATIVE-STREAM ((EXPS CONS)))", ((cpp_function_code)(&cpp_output_print_native_stream)), NULL);
      define_function_object("CPP-INDENTABLE-BINARY-OPERATOR?", "(DEFUN (CPP-INDENTABLE-BINARY-OPERATOR? BOOLEAN) ((OPERATOR STRING-WRAPPER)))", ((cpp_function_code)(&cpp_indentable_binary_operatorP)), NULL);
      define_function_object("CPP-COMMUTATIVE-BINARY-OPERATOR?", "(DEFUN (CPP-COMMUTATIVE-BINARY-OPERATOR? BOOLEAN) ((OPERATOR STRING-WRAPPER)))", ((cpp_function_code)(&cpp_commutative_binary_operatorP)), NULL);
      define_function_object("CPP-BINARY-OPERATOR?", "(DEFUN (CPP-BINARY-OPERATOR? BOOLEAN) ((STATEMENT OBJECT)))", ((cpp_function_code)(&cpp_binary_operatorP)), NULL);
      define_function_object("CPP-OPERATOR?", "(DEFUN (CPP-OPERATOR? BOOLEAN) ((STATEMENT OBJECT)))", ((cpp_function_code)(&cpp_operatorP)), NULL);
      define_function_object("CPP-ASSIGNMENT?", "(DEFUN (CPP-ASSIGNMENT? BOOLEAN) ((STATEMENT CONS)))", ((cpp_function_code)(&cpp_assignmentP)), NULL);
      define_function_object("CPP-OUTPUT-UNARY-OPERATOR", "(DEFUN CPP-OUTPUT-UNARY-OPERATOR ((EXPRESSION CONS)))", ((cpp_function_code)(&cpp_output_unary_operator)), NULL);
      define_function_object("CPP-NESTED-OPERATOR-NEEDS-PARENTHESES?", "(DEFUN (CPP-NESTED-OPERATOR-NEEDS-PARENTHESES? BOOLEAN) ((OP STRING-WRAPPER) (NESTED OBJECT)))", ((cpp_function_code)(&cpp_nested_operator_needs_parenthesesP)), NULL);
      define_function_object("CPP-HELP-OUTPUT-BINARY-OPERATOR", "(DEFUN CPP-HELP-OUTPUT-BINARY-OPERATOR ((EXPRESSION CONS) (NESTLEVEL INTEGER)))", ((cpp_function_code)(&cpp_help_output_binary_operator)), NULL);
      define_function_object("CPP-OUTPUT-BINARY-OPERATOR", "(DEFUN CPP-OUTPUT-BINARY-OPERATOR ((EXPRESSION CONS)))", ((cpp_function_code)(&cpp_output_binary_operator)), NULL);
      define_function_object("CPP-OUTPUT-TERNARY-OPERATOR", "(DEFUN CPP-OUTPUT-TERNARY-OPERATOR ((EXPRESSION CONS)))", ((cpp_function_code)(&cpp_output_ternary_operator)), NULL);
      define_function_object("CPP-OUTPUT-STATEMENT-LINE", "(DEFUN CPP-OUTPUT-STATEMENT-LINE ((STATEMENT CONS)))", ((cpp_function_code)(&cpp_output_statement_line)), NULL);
      define_function_object("CPP-OUTPUT-RETURN", "(DEFUN CPP-OUTPUT-RETURN ((RETURNSTATEMENT CONS)))", ((cpp_function_code)(&cpp_output_return)), NULL);
      define_function_object("CPP-OUTPUT-TYPE-EXPRESSION", "(DEFUN CPP-OUTPUT-TYPE-EXPRESSION ((TYPEEXPRESSION (CONS OF STRING-WRAPPER))))", ((cpp_function_code)(&cpp_output_type_expression)), NULL);
      define_function_object("CPP-OUTPUT-TYPED-ENTITY", "(DEFUN CPP-OUTPUT-TYPED-ENTITY ((TYPE OBJECT) (ENTITY OBJECT) (INITIALVALUE OBJECT)))", ((cpp_function_code)(&cpp_output_typed_entity)), NULL);
      define_function_object("CPP-OUTPUT-DECLARATIONS", "(DEFUN CPP-OUTPUT-DECLARATIONS ((ACCESSCONTROLMODE KEYWORD) (DECLARATIONS (CONS OF CONS))))", ((cpp_function_code)(&cpp_output_declarations)), NULL);
      define_function_object("CPP-OUTPUT-SIGNATURE", "(DEFUN CPP-OUTPUT-SIGNATURE ((SIGNATURE CONS) (OUTPUTMETHODCLASS? BOOLEAN)))", ((cpp_function_code)(&cpp_output_signature)), NULL);
      define_function_object("CPP-OUTPUT-SIGNATURES", "(DEFUN CPP-OUTPUT-SIGNATURES ((ACCESSCONTROLMODE KEYWORD) (SIGNATURES CONS)))", ((cpp_function_code)(&cpp_output_signatures)), NULL);
      define_function_object("CPP-OUTPUT-DEFINITIONS", "(DEFUN CPP-OUTPUT-DEFINITIONS ((ACCESSCONTROLMODE KEYWORD) (DEFINITIONS CONS)))", ((cpp_function_code)(&cpp_output_definitions)), NULL);
      define_function_object("CPP-OUTPUT-PROGN", "(DEFUN CPP-OUTPUT-PROGN ((PROGN CONS)))", ((cpp_function_code)(&cpp_output_progn)), NULL);
      define_function_object("CPP-OUTPUT-BLOCK", "(DEFUN CPP-OUTPUT-BLOCK ((BLOCK CONS)))", ((cpp_function_code)(&cpp_output_block)), NULL);
      define_function_object("CPP-OUTPUT-WITH-PROCESS-LOCK", "(DEFUN CPP-OUTPUT-WITH-PROCESS-LOCK ((SYNCH CONS)))", ((cpp_function_code)(&cpp_output_with_process_lock)), NULL);
      define_function_object("CPP-OUTPUT-STATIC-MEMBER-VARS", "(DEFUN CPP-OUTPUT-STATIC-MEMBER-VARS ((CLASS STRING-WRAPPER) (DECLARATIONS (CONS OF CONS))))", ((cpp_function_code)(&cpp_output_static_member_vars)), NULL);
      define_function_object("CPP-OUTPUT-DERIVED-CLASSES", "(DEFUN CPP-OUTPUT-DERIVED-CLASSES ((CLASSLIST CONS)))", ((cpp_function_code)(&cpp_output_derived_classes)), NULL);
      define_function_object("CPP-OUTPUT-TEMPLATE-PARAMETERS", "(DEFUN CPP-OUTPUT-TEMPLATE-PARAMETERS ((PARAMETERS CONS)))", ((cpp_function_code)(&cpp_output_template_parameters)), NULL);
      define_function_object("CPP-OUTPUT-TEMPLATE-CLASSES?", "(DEFUN (CPP-OUTPUT-TEMPLATE-CLASSES? BOOLEAN) ())", ((cpp_function_code)(&cpp_output_template_classesP)), NULL);
      define_function_object("CPP-OUTPUT-CLASS", "(DEFUN CPP-OUTPUT-CLASS ((CLASSDEF CONS)))", ((cpp_function_code)(&cpp_output_class)), NULL);
      define_function_object("CPP-OUTPUT-FORMAL-PARAMETERS", "(DEFUN CPP-OUTPUT-FORMAL-PARAMETERS ((PARAMETERS (CONS OF CONS))))", ((cpp_function_code)(&cpp_output_formal_parameters)), NULL);
      define_function_object("CPP-ARGUMENT-IS-STREAM?", "(DEFUN (CPP-ARGUMENT-IS-STREAM? BOOLEAN) ((ARG OBJECT)))", ((cpp_function_code)(&cpp_argument_is_streamP)), NULL);
      define_function_object("CPP-OUTPUT-ONE-ACTUAL-PARAMETER", "(DEFUN CPP-OUTPUT-ONE-ACTUAL-PARAMETER ((PARAMETER OBJECT)))", ((cpp_function_code)(&cpp_output_one_actual_parameter)), NULL);
      define_function_object("CPP-OUTPUT-ACTUAL-PARAMETERS", "(DEFUN CPP-OUTPUT-ACTUAL-PARAMETERS ((PARAMETERS CONS)))", ((cpp_function_code)(&cpp_output_actual_parameters)), NULL);
      define_function_object("CPP-OUTPUT-METHOD-SETTER-CALL", "(DEFUN CPP-OUTPUT-METHOD-SETTER-CALL ((METHODSETTERCALL CONS)))", ((cpp_function_code)(&cpp_output_method_setter_call)), NULL);
      define_function_object("CPP-OUTPUT-METHOD-CALL", "(DEFUN CPP-OUTPUT-METHOD-CALL ((METHODCALL CONS)))", ((cpp_function_code)(&cpp_output_method_call)), NULL);
      define_function_object("CPP-OUTPUT-REFERENCED-METHOD-CALL", "(DEFUN CPP-OUTPUT-REFERENCED-METHOD-CALL ((METHODCALL CONS)))", ((cpp_function_code)(&cpp_output_referenced_method_call)), NULL);
      define_function_object("CPP-OUTPUT-FUNCTION-CALL", "(DEFUN CPP-OUTPUT-FUNCTION-CALL ((FUNCTIONCALL CONS)))", ((cpp_function_code)(&cpp_output_function_call)), NULL);
      define_function_object("CPP-OUTPUT-DEFPRINT-SIGNATURE", "(DEFUN CPP-OUTPUT-DEFPRINT-SIGNATURE ((DEFPRINT CONS)))", ((cpp_function_code)(&cpp_output_defprint_signature)), NULL);
      define_function_object("CPP-OUTPUT-DEFPRINT", "(DEFUN CPP-OUTPUT-DEFPRINT ((DEFPRINT CONS)))", ((cpp_function_code)(&cpp_output_defprint)), NULL);
      define_function_object("CPP-OUTPUT-FUNCTION-SIGNATURE", "(DEFUN CPP-OUTPUT-FUNCTION-SIGNATURE ((FUNCTION CONS)))", ((cpp_function_code)(&cpp_output_function_signature)), NULL);
      define_function_object("CPP-OUTPUT-FUNCTION", "(DEFUN CPP-OUTPUT-FUNCTION ((FUNCTION CONS)))", ((cpp_function_code)(&cpp_output_function)), NULL);
      define_function_object("STARTUP-CPP-OUTPUT", "(DEFUN STARTUP-CPP-OUTPUT () :PUBLIC? TRUE)", ((cpp_function_code)(&startup_cpp_output)), NULL);
      { Method_Slot* function = lookup_function(SYM_CPP_OUTPUT_STELLA_STARTUP_CPP_OUTPUT);

        set_dynamic_slot_value(function->dynamic_slots, SYM_CPP_OUTPUT_STELLA_METHOD_STARTUP_CLASSNAME, wrap_string("Startup-Cpp-Output"), NULL_STRING_WRAPPER);
      }
    }
    if (current_startup_time_phaseP(8)) {
      finalize_slots();
      cleanup_unfinalized_classes();
    }
    if (current_startup_time_phaseP(9)) {
      define_stella_global_variable_from_stringified_source("(DEFSPECIAL *CPP-INDENT-CHARS* INTEGER 0)");
      define_stella_global_variable_from_stringified_source("(DEFSPECIAL *OUTPUTTINGDEFPRINT?* BOOLEAN FALSE :DOCUMENTATION \"`true' when outputting a defprint, used to \n            conditionally dereference streams in print-native-stream \n            statements.  Also used to take the address of streams\n            when passed to functions inside of a defprint\")");
      store_macro(SYM_CPP_OUTPUT_STELLA_CPP_OUTPUT_TO_STRING, SYM_CPP_OUTPUT_STELLA_CPP_OUTPUT_TO_STRING_EXPANDER, ((cpp_function_code)(&cpp_output_to_string_expander)));
    }
  }
}

Symbol* SYM_CPP_OUTPUT_STELLA_VRLET = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_STRING = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_NULL = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_SPECIAL = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_oCURRENT_STREAMo = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_NEW = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_OUTPUT_STRING_STREAM = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_SETQ = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_THE_STRING = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CAST = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_OUTPUT_TO_STRING = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_OUTPUT_TO_STRING_EXPANDER = NULL;

Surrogate* SGT_CPP_OUTPUT_STELLA_CONS = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_PROGN = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_STATEMENTS = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_COMMENT = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_CLASS = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_HANDLER_CASE = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_CATCH = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_SIGNAL = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_UNWIND_PROTECT = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_VERBATIM = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_CAST = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_GLOBAL = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_SPECIAL = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_LOCAL = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_TYPE = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_DEREFERENCE = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_ARRAY_REFERENCE = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_WITH_PROCESS_LOCK = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_BREAK = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_CONTINUE = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_IF = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_FUNCTION_SIGNATURE = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_METHOD_SIGNATURE = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_COND = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_CASE = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_WHEN = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_UNLESS = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_ASSIGN = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_LOOP = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_WHILE = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_FOREACH = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_BLOCK = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_IDENT = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_PRINT_STREAM = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_PRINT_NATIVE_STREAM = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_LITERAL = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_FUNCTION = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_METHOD = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_RETURN = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_SYMBOL = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_MAKE = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_FUNCALL = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_METHOD_CODE_CALL = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_FUNCTION_POINTER = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_METHOD_POINTER = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_SLOT_VALUE = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_REFERENCED_SLOT_VALUE = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_SLOT_VALUE_SETTER = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_DECLARATIONS = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_DEFINITIONS = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_SIGNATURES = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_UNARY_OP = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_BINARY_OP = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_TERNARY_OP = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_FUNCTION_CALL = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_METHOD_SETTER_CALL = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_METHOD_CALL = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_REFERENCED_METHOD_CALL = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_ACTUALS = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_DEFPRINT = NULL;

Keyword* KWD_CPP_OUTPUT_UNBIND_WITH_DESTRUCTORS = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_NEWLINE = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_NULL_VALUE = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_ASSIGN = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_SCOLON = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_LPAREN = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_RPAREN = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_NEW = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_THROW = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_STANDARD_OUT = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_STANDARD_ERROR = NULL;

Keyword* KWD_CPP_OUTPUT_PUBLIC = NULL;

Keyword* KWD_CPP_OUTPUT_PRIVATE = NULL;

Keyword* KWD_CPP_OUTPUT_PROTECTED = NULL;

Keyword* KWD_CPP_OUTPUT_CPP_STANDALONE = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_CPP_VAR_ARGS = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_STARTUP_CPP_OUTPUT = NULL;

Symbol* SYM_CPP_OUTPUT_STELLA_METHOD_STARTUP_CLASSNAME = NULL;

} // end of namespace stella
