// /tmp/build-stella/stella-3.0.0.beta/native/cpp/stella/idl-output.hh

/*--------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2001      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK ----------------------------*/



namespace stella {

// Global declarations:
extern DECLARE_STELLA_SPECIAL(oIDL_INDENT_CHARSo, int );

// Function signatures:
void idl_output_parse_tree(Cons* constree);
void idl_output_statement(Object* statement);
void idl_indent();
void idl_bump_indent();
void idl_unbump_indent();
void idl_output_typedef(Cons* renamed_Typedef);
void idl_output_enumerands(Cons* enumerands);
void idl_output_enum(Cons* renamed_Enum);
void idl_output_type_expression(Cons* typeexpression);
void string_idl_output_literal(char* string);
void idl_output_atomic_expression(Object* atom);
void idl_output_comment(String_Wrapper* tree);
void idl_output_identifier(String_Wrapper* identifier);
void idl_output_derived_classes(Cons* class_list);
void idl_output_template_parameters(Cons* parameters);
boolean idl_output_template_classesP();
void idl_output_interface(Cons* classdef);
void idl_output_struct(Cons* classdef);
void idl_output_one_formal_parameter(Cons* parameter);
void idl_output_formal_parameters(Cons* parameters);
void idl_output_function_signature(Cons* function);
void idl_output_declarations(Cons* declarations);
void idl_output_signature(Cons* signature, boolean outputmethodclassP);
void idl_output_signatures(Cons* signatures);
void startup_idl_output();

// Auxiliary global declarations:
extern Surrogate* SGT_IDL_OUTPUT_STELLA_CONS;
extern Symbol* SYM_IDL_OUTPUT_STELLA_IDL_COMMENT;
extern Symbol* SYM_IDL_OUTPUT_STELLA_IDL_TYPEDEF;
extern Symbol* SYM_IDL_OUTPUT_STELLA_IDL_ENUM;
extern Symbol* SYM_IDL_OUTPUT_STELLA_IDL_INTERFACE;
extern Symbol* SYM_IDL_OUTPUT_STELLA_IDL_STRUCT;
extern Symbol* SYM_IDL_OUTPUT_STELLA_IDL_DECLARATIONS;
extern Symbol* SYM_IDL_OUTPUT_STELLA_IDL_IDENT;
extern Symbol* SYM_IDL_OUTPUT_STELLA_IDL_TYPE;
extern Symbol* SYM_IDL_OUTPUT_STELLA_IDL_SIGNATURES;
extern Symbol* SYM_IDL_OUTPUT_STELLA_IDL_VAR_ARGS;
extern Symbol* SYM_IDL_OUTPUT_STELLA_STARTUP_IDL_OUTPUT;
extern Symbol* SYM_IDL_OUTPUT_STELLA_METHOD_STARTUP_CLASSNAME;


} // end of namespace stella
