// /tmp/build-stella/stella-3.0.0.beta/native/cpp/stella/iterators.hh

/*--------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2001      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK ----------------------------*/




namespace stella {

// Function signatures:
boolean terminate_destructive_list_iteratorP(Destructive_List_Iterator* self);
boolean filtered_nested_iterator_nextP(All_Purpose_Iterator* self);
boolean iterator_cons_list_nextP(All_Purpose_Iterator* self);
boolean iterator_cons_list_emptyP(All_Purpose_Iterator* self);
boolean filtered_concatenated_iterator_nextP(All_Purpose_Iterator* self);
Integer_Interval_Iterator* interval(int lowerbound, int upperbound);
void initialize_reverse_integer_interval_iterator(Reverse_Integer_Interval_Iterator* self);
Reverse_Integer_Interval_Iterator* reverse_interval(int lowerbound, int upperbound);
String_Iterator* string_allocate_iterator(char* self);
Iterator* allocate_all_meta_objects_iterator(int arraysize, cpp_function_code nextcode, Module* module, boolean localP);
boolean selected_meta_objectP(All_Purpose_Iterator* self, Module* objectmodule);
boolean all_symbols_nextP(All_Purpose_Iterator* self);
Iterator* all_symbols(Module* module, boolean localP);
boolean filter_public_slotP(Slot* self, All_Purpose_Iterator* iterator);
boolean filter_private_slotP(Slot* self, All_Purpose_Iterator* iterator);
boolean filter_method_slotP(Slot* self, All_Purpose_Iterator* iterator);
boolean filter_public_method_slotP(Slot* self, All_Purpose_Iterator* iterator);
boolean filter_non_external_slotP(Slot* self, All_Purpose_Iterator* iterator);
boolean filter_non_parameter_slotP(Slot* self, All_Purpose_Iterator* iterator);
boolean filter_non_auxiliary_slotP(Slot* self, All_Purpose_Iterator* iterator);
boolean filter_slotP(Slot* self, All_Purpose_Iterator* iterator);
boolean all_functions_nextP(All_Purpose_Iterator* self);
Iterator* all_functions(Module* module, boolean localP);
Iterator* all_public_functions(Module* module, boolean localP);
boolean all_variables_nextP(All_Purpose_Iterator* self);
Iterator* all_variables(Module* module, boolean localP);
boolean all_surrogates_nextP(All_Purpose_Iterator* self);
Iterator* all_surrogates(Module* module, boolean localP);
boolean all_classes_nextP(All_Purpose_Iterator* self);
Iterator* all_classes(Module* module, boolean localP);
boolean slots_nextP(All_Purpose_Iterator* self);
Iterator* all_slots(Module* module, boolean localP);
Iterator* all_methods(Module* module, boolean localP);
Iterator* all_public_methods(Module* module, boolean localP);
boolean class_methods_nextP(All_Purpose_Iterator* self);
Iterator* class_methods(Class* renamed_Class, Cons* filters);
Iterator* public_class_methods(Class* renamed_Class);
Iterator* private_class_methods(Class* renamed_Class);
boolean class_storage_slots_nextP(All_Purpose_Iterator* self);
Iterator* class_storage_slots(Class* renamed_Class, Cons* filters);
boolean class_tables_nextP(All_Purpose_Iterator* self);
Iterator* class_tables(Class* renamed_Class, Cons* filters);
Iterator* public_class_storage_slots(Class* renamed_Class);
Iterator* private_class_storage_slots(Class* renamed_Class);
void help_startup_iterators1();
void startup_iterators();

// Auxiliary global declarations:
extern Symbol* SYM_ITERATORS_STELLA_SLOT_AUXILIARYp;
extern Surrogate* SGT_ITERATORS_STELLA_TABLE;
extern Symbol* SYM_ITERATORS_STELLA_STARTUP_ITERATORS;
extern Symbol* SYM_ITERATORS_STELLA_METHOD_STARTUP_CLASSNAME;


} // end of namespace stella
