// /tmp/build-stella/stella-3.0.0.beta/native/cpp/stella/java-output.hh

/*--------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2001      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK ----------------------------*/



namespace stella {

// Global declarations:
extern DECLARE_STELLA_SPECIAL(oJAVA_INDENT_CHARSo, int );
extern Key_Value_List* oJAVA_STELLA_PACKAGE_MAPPINGo;
extern Cons* oJAVA_SEMICOLON_STATEMENTSo;

// Function signatures:
char* java_stella_package();
void java_output_parse_tree(Cons* constree);
void java_bump_indent();
void java_unbump_indent();
void java_indent();
void java_output_statement(Object* statement);
void java_maybe_output_statement_with_parentheses(Object* statement);
void java_output_identifier(String_Wrapper* identifier);
void string_java_output_literal(char* string);
void java_output_make_array(Cons* statement);
void java_output_array(Cons* arrayelements);
void java_output_anonymous_array(Cons* statement);
void java_output_aref(Cons* statement);
void java_output_slot_value(Cons* statement);
void java_output_slot_value_setter(Cons* statement);
void java_output_implements_interfaces(Cons* interfacelist);
void java_output_class(Cons* classdef, boolean exceptionclassP);
void java_output_class_declaration(Cons* classdef);
void java_output_class_variable_definitions(Cons* variabletranslations);
void java_output_class_constructors(Cons* constructors, char* classname, boolean exceptionclassP);
void java_output_class_methods(Cons* methods);
void java_output_exception_constructor(char* exceptionname);
void java_output_named_statement(Cons* namedstatement);
void java_output_formal_parameters(Cons* parameters);
void java_output_method_signature(Cons* method);
Cons* java_separate_comment_from_body(Cons* body, Cons*& _return1);
void java_output_method(Cons* method);
void java_output_type_expression(Cons* typeexpression);
boolean java_output_semicolonP(Cons* statement);
boolean java_indent_statementP(Cons* statement);
boolean java_illegal_statementP(Cons* statement);
void java_output_statements(Cons* statementlist);
void java_output_declarations(Cons* declarations);
char* java_heuristically_translate_name(char* stella_name, Cons* case_converted_name_list);
void java_output_comment_string(char* comment, char* comment_start, char* comment_continuation, char* comment_end, boolean javadoc_commentP, Cons* case_converted_name_list);
void java_output_comment(String_Wrapper* tree);
void java_output_javadoc_comment(String_Wrapper* tree, Cons* parameter_names_and_types, String_Wrapper* return_value, char* author, char* version);
void java_output_verbatim(String_Wrapper* verbatimstatement);
void java_output_make(Cons* statement);
void java_output_cast(Cons* tree);
void java_output_progn(Cons* progn);
void java_output_block(Cons* block);
void java_output_with_process_lock(Cons* synch);
void java_output_return(Cons* returnstatement);
void java_output_throw(Cons* tree);
void java_output_catch(Cons* tree);
void java_output_unwind_protect(Cons* tree);
void java_output_handler_case(Cons* tree);
void java_output_signal(Cons* tree);
void java_output_global_definition(Cons* global);
void java_output_special_definition(Cons* special);
void java_output_actuals_as_cons_expression(Cons* arglist);
void java_output_funcall(Cons* funcall);
void java_output_method_code_call(Cons* methodcall);
void java_output_break(Cons* tag);
void java_output_continue(Cons* tag);
boolean java_statement_returnsP(Cons* statement);
boolean java_last_statement_returnsP(Cons* statements);
void java_output_case(Cons* renamed_Case);
void java_output_cond(Cons* cond);
boolean java_prognP(Object* tree);
boolean java_blockP(Object* tree);
void java_output_if(Cons* tree);
void java_output_when(Cons* tree);
void java_output_unless(Cons* tree);
void java_output_assignment(Cons* assignment);
void java_output_loop(Cons* loop);
void java_output_while(Cons* loop);
void java_output_foreach(Cons* loop);
boolean java_end_of_line_tokenP(Object* token);
void java_output_print_stream(Cons* exps, boolean nativestreamP);
void java_help_output_print_stream(Object* stream, Cons* exps, boolean nativestreamP, boolean endoflineP);
boolean java_indentable_binary_operatorP(String_Wrapper* renamed_Operator);
boolean java_commutative_binary_operatorP(String_Wrapper* renamed_Operator);
boolean java_binary_operatorP(Object* statement);
boolean java_operatorP(Object* statement);
void java_output_unary_operator(Cons* expression);
boolean java_nested_operator_needs_parenthesesP(String_Wrapper* op, Object* nested);
void java_help_output_binary_operator(Cons* expression, int nestlevel);
void java_output_binary_operator(Cons* expression);
void java_output_ternary_operator(Cons* expression);
void java_output_method_call(Cons* methodcall);
void java_output_function_call(Cons* functioncall);
void java_output_actual_parameters(Cons* parameters);
void help_startup_java_output1();
void help_startup_java_output2();
void help_startup_java_output3();
void startup_java_output();

// Auxiliary global declarations:
extern Surrogate* SGT_JAVA_OUTPUT_STELLA_CONS;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_CLASS;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_EXCEPTION_CLASS;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_NAMED_STATEMENT;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_STATEMENTS;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_IDENT;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_EOL;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_LITERAL;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_COMMENT;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_SYMBOL;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_CATCH;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_THROW;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_UNWIND_PROTECT;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_HANDLER_CASE;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_SIGNAL;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_VERBATIM;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_CAST;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_GLOBAL;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_SPECIAL;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_TYPE;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_PROGN;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_BLOCK;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_WITH_PROCESS_LOCK;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_RETURN;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_MAKE;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_FUNCALL;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_METHOD_CODE_CALL;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_ASSIGN;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_BREAK;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_CONTINUE;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_COND;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_CASE;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_IF;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_WHEN;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_UNLESS;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_LOOP;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_WHILE;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_FOREACH;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_SLOT_VALUE;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_SLOT_VALUE_SETTER;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_UNARY_OP;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_BINARY_OP;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_TERNARY_OP;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_FUNCTION_CALL;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_METHOD_CALL;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_ACTUALS;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_MAKE_ARRAY;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_ARRAY_INITIALIZER;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_ANONYMOUS_ARRAY;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_AREF;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_METHOD;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_FUNCTION;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_PRINT_STREAM;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_PRINT_NATIVE_STREAM;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_DECLARATIONS;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_FUNCTION_POINTER;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_METHOD_POINTER;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_METHOD_SETTER_CALL;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_NEW;
extern Keyword* KWD_JAVA_OUTPUT_NO;
extern Keyword* KWD_JAVA_OUTPUT_PRESERVE;
extern Keyword* KWD_JAVA_OUTPUT_CLEVER;
extern Keyword* KWD_JAVA_OUTPUT_UPCASE;
extern Keyword* KWD_JAVA_OUTPUT_TITLECASEX;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_STANDARD_OUT;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_JAVA_STANDARD_ERROR;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_STARTUP_JAVA_OUTPUT;
extern Symbol* SYM_JAVA_OUTPUT_STELLA_METHOD_STARTUP_CLASSNAME;


} // end of namespace stella
